/**
//*****************************************************************************
// @file	ErrorLookupDP.cpp
// @brief	CErrorLookupNX
// @author	?鎛
// @date	$Date:   2007/03/06 20:32:18  $
//****************************************************************************/
// @date	
//	- Jan/07/2005	?鎛	VK쐬
//	- Jan/09/2005	?鎛	pǉ
//	- Jan/14/2005	?鎛	kCAM_UPDATE_ERRORǉ
//	- Nov/05/2007	?鎛	VS2005ZLACRTΉ
//	- Jan/16/2008	?鎛	kCAM_LNK_INVALID_SEND_SIZEǉ
//	- Jan/17/2008	?鎛	kCAM_LNK_INVALID_BAUDRATEǉ
//	- Jan/23/2008	?鎛	kCAM_LNK_NO_DEVICE, kCAM_LNK_UART_ERRORǉ
//*************************************************************<$NoKeywords: $>

#ifndef _USE_QT_
#include "stdafx.h"
#endif
#include "errorlookupdp.h"
#include <assert.h>


CErrorLookupDP::CErrorLookupDP(void)
{
}

CErrorLookupDP::~CErrorLookupDP(void)
{
}

BOOL CErrorLookupDP::GetName(CAM_ERROR kErrorCode, char *pszName, DWORD dwLength) const
{
	assert(MAX_NORMAL_ERROR	== kCAM_LNK_UART_ERROR);
	assert(MAX_DETAIL_ERROR	== kCAM_IFCARD_DEVICE_CAMERA_ERROR);
	assert(MAX_WARNING == kCAM_LV_INVALID_FRAME);

	char *pszWork = 0;

	switch (kErrorCode)
	{
	case kCAM_NO_ERROR:
		pszWork = "kCAM_NO_ERROR";
		break;
	case kCAM_API_INVALID_OBJECT:
		pszWork = "kCAM_API_INVALID_OBJECT";
		break;
	case kCAM_API_INVALID_PARAM:
		pszWork = "kCAM_API_INVALID_PARAM";
		break;
	case kCAM_API_PARAM_OUT_OF_RANGE:
		pszWork = "kCAM_API_PARAM_OUT_OF_RANGE";
		break;
	case kCAM_API_CALLED_IN_INVALID_STATE:
		pszWork = "kCAM_API_CALLED_IN_INVALID_STATE";
		break;
	case kCAM_API_LIB_INITIALIZE_ERROR:
		pszWork = "kCAM_API_LIB_INITIALIZE_ERROR";
		break;
	case kCAM_API_INTERNAL_ERROR:
		pszWork = "kCAM_API_INTERNAL_ERROR";
		break;
	case kCAM_WRONG_SYNCHRONIZED_MODE:
		pszWork = "kCAM_WRONG_SYNCHRONIZED_MODE";
		break;
	case kCAM_WINAPI_ERROR:
		pszWork = "kCAM_WINAPI_ERROR";
		break;
	case kCAM_WINAPI_CANNOT_START_TIMEOUT_TIMER:
		pszWork = "kCAM_WINAPI_CANNOT_START_TIMEOUT_TIMER";
		break;
	case kCAM_NOT_SUPPORTED:
		pszWork = "kCAM_NOT_SUPPORTED";
		break;
	/// JԂ̃ZbgAbvɊւG?
	case kCAM_API_OBJECT_ALREADY_CREATED:
		pszWork = "kCAM_API_OBJECT_ALREADY_CREATED";
		break;
	case kCAM_INVALID_CAMERA_ID:
		pszWork = "kCAM_INVALID_CAMERA_ID";
		break;
	case kCAM_CANNOT_COPY_ENUMERATED_CAMERA_ID:
		pszWork = "kCAM_CANNOT_COPY_ENUMERATED_CAMERA_ID";
		break;
	case kCAM_INVALID_CAMERA_MODE:
		pszWork = "kCAM_INVALID_CAMERA_MODE";
		break;
	case kCAM_INVALID_CALLBACK_ID:
		pszWork = "kCAM_INVALID_CALLBACK_ID";
		break;
	case kCAM_INVALID_ERROR:
		pszWork = "kCAM_INVALID_ERROR";
		break;
	case kCAM_INVALID_CALLBACK_FUNC:
		pszWork = "kCAM_INVALID_CALLBACK_FUNC";
		break;
	case kCAM_NO_CALLBACK_FUNC:
		pszWork = "kCAM_NO_CALLBACK_FUNC";
		break;
	case kCAM_INITIALIZE_TIMEOUT:
		pszWork = "kCAM_INITIALIZE_TIMEOUT";
		break;
	case kCAM_INVALID_POWER_STATE:
		pszWork = "kCAM_INVALID_POWER_STATE";
		break;
	case kCAM_ALREADY_POWER_STATE_SET:
		pszWork = "kCAM_ALREADY_POWER_STATE_SET";
		break;
	case kCAM_INVALID_TIMEOUT:
		pszWork = "kCAM_INVALID_TIMEOUT";
		break;
	case kCAM_INVALID_LIGHT_PATH_SHUTTER_STATE:
		pszWork = "kCAM_INVALID_LIGHT_PATH_SHUTTER_STATE";
		break;
	/// IoɊւG?
	case kCAM_AE_INVALID_ADJUSTMENT_PARAM:
		pszWork = "kCAM_AE_INVALID_ADJUSTMENT_PARAM";
		break;
	case kCAM_AE_INVALID_EVAL_FUNC:
		pszWork = "kCAM_AE_INVALID_EVAL_FUNC";
		break;
	case kCAM_AE_INVALID_REGION:
		pszWork = "kCAM_AE_INVALID_REGION";
		break;
	case kCAM_AE_INVALID_LOCK_STATE:
		pszWork = "kCAM_AE_INVALID_LOCK_STATE";
		break;
	case kCAM_AE_INVALID_TARGET_VALUE:
		pszWork = "kCAM_AE_INVALID_TARGET_VALUE";
		break;
	case kCAM_AE_ALREADY_LOCK_STATE_SET:
		pszWork = "kCAM_AE_ALREADY_LOCK_STATE_SET";
		break;
	case kCAM_AE_NO_EVAL_FUNC:
		pszWork = "kCAM_AE_NO_EVAL_FUNC";
		break;
	case kCAM_EXP_AE_NORMAL_ONETIME_TIMEOUT:
		pszWork = "kCAM_EXP_AE_NORMAL_ONETIME_TIMEOUT";
		break;
	case kCAM_EXP_AE_SFL_ONETIME_TIMEOUT:
		pszWork = "kCAM_EXP_AE_SFL_ONETIME_TIMEOUT";
		break;
	/// IoɊւG?
	case kCAM_EXP_INVALID_MODE:
		pszWork = "kCAM_EXP_INVALID_MODE";
		break;
	case kCAM_EXP_INVALID_SHUTTER_SPEED:
		pszWork = "kCAM_EXP_INVALID_SHUTTER_SPEED";
		break;
	case kCAM_EXP_INVALID_ISO:
		pszWork = "kCAM_EXP_INVALID_ISO";
		break;
	case kCAM_EXP_INVALID_ISO_GAIN:
		pszWork = "kCAM_EXP_INVALID_ISO_GAIN";
		break;
	case kCAM_EXP_INVALID_GAINED_EXPOSURE_MODE:
		pszWork = "kCAM_EXP_INVALID_GAINED_EXPOSURE_MODE";
		break;
	case kCAM_EXP_INVALID_CCD_SENSITIVITY_MODE:
		pszWork = "kCAM_EXP_INVALID_CCD_SENSITIVITY_MODE";
		break;
	case kCAM_EXP_ALREADY_MODE_SET:
		pszWork = "kCAM_EXP_ALREADY_MODE_SET";
		break;
	case kCAM_EXP_INVALID_APPROPRIATEEXPCOUNT:
		pszWork = "kCAM_EXP_INVALID_APPROPRIATEEXPCOUNT";
		break;
	case kCAM_EXP_INVALID_ONETIME_TIMEOUT:
		pszWork = "kCAM_EXP_INVALID_ONETIME_TIMEOUT";
		break;
	case kCAM_EXP_INVALID_REAL_EXPOSURE_LIMIT:
		pszWork = "kCAM_EXP_INVALID_REAL_EXPOSURE_LIMIT";
		break;

	/// tH?JXɊւG?
	case kCAM_FCS_INVALID_FOCUSMODE:
		pszWork = "kCAM_FCS_INVALID_FOCUSMODE";
		break;
	case kCAM_FCS_INVALID_REGION:
		pszWork = "kCAM_FCS_INVALID_REGION";
		break;
	/// WBɊւG?
	case kCAM_WB_CALIBRATE_ERROR:
		pszWork = "kCAM_WB_CALIBRATE_ERROR";
		break;
	case kCAM_WB_CALIBRATE_TIMEOUT:	
		pszWork = "kCAM_WB_CALIBRATE_TIMEOUT";
		break;
	case kCAM_WB_INVALID_MODE:
		pszWork = "kCAM_WB_INVALID_MODE";
		break;
	case kCAM_WB_INVALID_REGION:
		pszWork = "kCAM_WB_INVALID_REGION";
		break;
	case kCAM_WB_INVALID_GAIN:
		pszWork = "kCAM_WB_INVALID_GAIN";
		break;
	case kCAM_WB_CANNOT_SET_SPECIFIED_WB:
		pszWork = "kCAM_WB_CANNOT_SET_SPECIFIED_WB";
		break;
	/// BBɊւG?
	case kCAM_BB_CALIBRATE_ERROR:
		pszWork = "kCAM_BB_CALIBRATE_ERROR";
		break;
	case kCAM_BB_CALIBRATE_TIMEOUT:
		pszWork = "kCAM_BB_CALIBRATE_TIMEOUT";
		break;
	case kCAM_BB_INVALID_MODE:
		pszWork = "kCAM_BB_INVALID_MODE";
		break;
	case kCAM_BB_INVALID_REGION:
		pszWork = "kCAM_BB_INVALID_REGION";
		break;
	case kCAM_BB_INVALID_OFFSET:
		pszWork = "kCAM_BB_INVALID_OFFSET";
		break;
	/// 摜ɊւG?
	case kCAM_IP_INVALID_ORIENTATION:
		pszWork = "kCAM_IP_INVALID_ORIENTATION";
		break;
	case kCAM_IP_INVALID_SHARPNESS:
		pszWork = "kCAM_IP_INVALID_SHARPNESS";
		break;
	case kCAM_IP_INVALID_COLOR_MODE:
		pszWork = "kCAM_IP_INVALID_COLOR_MODE";
		break;
	case kCAM_IP_INVALID_LEVEL_ADJUST:
		pszWork = "kCAM_IP_INVALID_LEVEL_ADJUST";
		break;
	case kCAM_IP_INVALID_LUT:
		pszWork = "kCAM_IP_INVALID_LUT";
		break;
	case kCAM_IP_INVALID_DARK_IMAGE_TIMES:
		pszWork = "kCAM_IP_INVALID_DARK_IMAGE_TIMES";
		break;
	case kCAM_IP_INVALID_NOISE_REDUCTION:
		pszWork = "kCAM_IP_INVALID_NOISE_REDUCTION";
		break;
	/// ɊւG?
	case kCAM_LV_INVALID_IMAGE_SIZE:
		pszWork = "kCAM_LV_INVALID_IMAGE_SIZE";
		break;
	case kCAM_LV_INVALID_BINNING_MODE:
		pszWork = "kCAM_LV_INVALID_BINNING_MODE";
		break;
	case kCAM_LV_CANNOT_SET_SPECIFIED_BINNING_MODE:
		pszWork = "kCAM_LV_CANNOT_SET_SPECIFIED_BINNING_MODE";
		break;
	case kCAM_LV_INVALID_ZOOM:
		pszWork = "kCAM_LV_INVALID_ZOOM";
		break;
	case kCAM_LV_INVALID_ZOOM_REGION:
		pszWork = "kCAM_LV_INVALID_ZOOM_REGION";
		break;
	case kCAM_LV_CANNOT_SET_SPECIFIED_ZOOM:
		pszWork = "kCAM_LV_CANNOT_SET_SPECIFIED_ZOOM";
		break;
	case kCAM_LV_INVALID_CCD_IMAGE_TYPE:
		pszWork = "kCAM_LV_INVALID_CCD_IMAGE_TYPE";
		break;
	case kCAM_LV_MOVIE_ERROR:
		pszWork = "kCAM_LV_MOVIE_ERROR";
		break;
	case kCAM_LV_MOVIE_TIMEOUT:
		pszWork = "kCAM_LV_MOVIE_TIMEOUT";
		break;
	case kCAM_LV_INVALID_BIT_A_PIXEL:
		pszWork = "kCAM_LV_INVALID_BIT_A_PIXEL";
		break;
	/// L?ɊւG?
	case kCAM_REC_START_ERROR:
		pszWork = "kCAM_REC_START_ERROR";
		break;
	case kCAM_REC_STOP_ERROR:
		pszWork = "kCAM_REC_STOP_ERROR";
		break;
	case kCAM_REC_LACK_OF_MEMORY:
		pszWork = "kCAM_REC_LACK_OF_MEMORY";
		break;
	case kCAM_REC_INVALID_FILENAME:
		pszWork = "kCAM_REC_INVALID_FILENAME";
		break;
	case kCAM_REC_INVALID_TRIMMINGREGION:
		pszWork = "kCAM_REC_INVALID_TRIMMINGREGION";
		break;
	case kCAM_REC_INVALID_FORMAT:
		pszWork = "kCAM_REC_INVALID_FORMAT";
		break;
	case kCAM_REC_INVALID_FRAMETIME:
		pszWork = "kCAM_REC_INVALID_FRAMETIME";
		break;
	/// ?ɊւG?
	case kCAM_SIA_INVALID_PRECAPTUE_MODE:
		pszWork = "kCAM_SIA_INVALID_PRECAPTUE_MODE";
		break;
	case kCAM_SIA_INVALID_ACCUMULATE_MODE:
		pszWork = "kCAM_SIA_INVALID_ACCUMULATE_MODE";
		break;
	case kCAM_SIA_INVALID_ACCUMULATE_TIMES:
		pszWork = "kCAM_SIA_INVALID_ACCUMULATE_TIMES";
		break;
	case kCAM_SIA_INVALID_BYTES_A_CHANNEL:
		pszWork = "kCAM_SIA_INVALID_BYTES_A_CHANNEL";
		break;
	case kCAM_SIA_INVALID_SHIFT_BITS_FOR_16:
		pszWork = "kCAM_SIA_INVALID_SHIFT_BITS_FOR_16";
		break;
	case kCAM_SIA_INVALID_IMAGE_SIZE:
		pszWork = "kCAM_SIA_INVALID_IMAGE_SIZE";
		break;
	case kCAM_SIA_CANNOT_SET_SPECIFIED_IMAGE_SIZE:
		pszWork = "kCAM_SIA_CANNOT_SET_SPECIFIED_IMAGE_SIZE";
		break;
	case kCAM_SIA_INVALID_BINNING_MODE:
		pszWork = "kCAM_SIA_INVALID_BINNING_MODE";
		break;
	case kCAM_SIA_CANNOT_SET_SPECIFIED_BINNING_MODE:
		pszWork = "kCAM_SIA_CANNOT_SET_SPECIFIED_BINNING_MODE";
		break;
	case kCAM_SIA_INVALID_TRIMMING_REGION:
		pszWork = "kCAM_SIA_INVALID_TRIMMING_REGION";
		break;
	case kCAM_SIA_CANNOT_CAPTURE:
		pszWork = "kCAM_SIA_CANNOT_CAPTURE";
		break;
	case kCAM_SIA_CANNOT_STOP:
		pszWork = "kCAM_SIA_CANNOT_STOP";
		break;
	case kCAM_SIA_CANNOT_GET_PROGRESS:
		pszWork = "kCAM_SIA_CANNOT_GET_PROGRESS";
		break;
	case kCAM_SIA_INVALID_CCD_IMAGE_TYPE:
		pszWork = "kCAM_SIA_INVALID_CCD_IMAGE_TYPE";
		break;
	case kCAM_SIA_CAPTURE_ERROR:
		pszWork = "kCAM_SIA_CAPTURE_ERROR";
		break;
	case kCAM_SIA_CAPTURE_TIMEOUT:
		pszWork = "kCAM_SIA_CAPTURE_TIMEOUT";
		break;
	case kCAM_SIA_INVALID_NOISE_REDUCTION_MODE:
		pszWork = "kCAM_SIA_INVALID_NOISE_REDUCTION_MODE";
		break;
	/// ʐMɊւG?
	case kCAM_COM_INVALID_COMMAND:
		pszWork = "kCAM_COM_INVALID_COMMAND";
		break;
	case kCAM_COM_INVALID_INTERRUPT:
		pszWork = "kCAM_COM_INVALID_INTERRUPT";
		break;
	case kCAM_COM_INVALID_PARAMETER:
		pszWork = "kCAM_COM_INVALID_PARAMETER";
		break;
	case kCAM_COM_PARAM_OUT_OF_RANGE:
		pszWork = "kCAM_COM_PARAM_OUT_OF_RANGE";
		break;
	case kCAM_COM_INVALID_MEMORY_ADDRESS:
		pszWork = "kCAM_COM_INVALID_MEMORY_ADDRESS";
		break;
	case kCAM_COM_TIMEOUT:
		pszWork = "kCAM_COM_TIMEOUT";
		break;
	case kCAM_IFCARD_COMMINUCATION_ERROR:
		pszWork = "kCAM_IFCARD_COMMINUCATION_ERROR";
		break;
	case kCAM_COM_BUFFER_FULL:
		pszWork = "kCAM_COM_BUFFER_FULL";
		break;
	/// JɊւG?
	case kCAM_CAMERA_ERROR:
		pszWork = "kCAM_CAMERA_ERROR";
		break;
	case kCAM_CAMERA_NOHEAD:
		pszWork = "kCAM_CAMERA_NOHEAD";
		break;
	case kCAM_CAMERA_WRONG_HEAD:
		pszWork = "kCAM_CAMERA_WRONG_HEAD";
		break;
	case kCAM_CCD_HOT_WARNING:
		pszWork = "kCAM_CCD_HOT_WARNING";
		break;
	case kCAM_CCD_COOL_WARNING:
		pszWork = "kCAM_CCD_COOL_WARNING";
		break;
	case kCAM_CCD_COOL_CAUTION:
		pszWork = "kCAM_CCD_COOL_CAUTION";
		break;
	case kCAM_HOT_WARNING:
		pszWork = "kCAM_HOT_WARNING";
		break;
	case kCAM_COOL_WARNING:
		pszWork = "kCAM_COOL_WARNING";
		break;
	case kCAM_CAMERA_DEVICE_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_ERROR";
		break;
	case kCAM_CAMERA_POWER_ERROR:
		pszWork = "kCAM_CAMERA_POWER_ERROR";
		break;
	case KCAM_CAMERA_NO_CAMPS:
		pszWork = "KCAM_CAMERA_NO_CAMPS";
		break;
	case kCAM_LIGHTPATH_SHUTTER_DEVICE_ERROR:
		pszWork = "kCAM_LIGHTPATH_SHUTTER_DEVICE_ERROR";
		break;
	case kCAM_CAMERA_CASE_HOT_WARNING:
		pszWork = "kCAM_CAMERA_CASE_HOT_WARNING";
		break;
	/// PCI??hɊւG?
	case kCAM_IFCARD_ERROR:
		pszWork = "kCAM_IFCARD_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_ERROR";
		break;
	case kCAM_IFCARD_CONFIGURATION_ERROR:
		pszWork = "kCAM_IFCARD_CONFIGURATION_ERROR";
		break;
	case kCAM_IFCARD_UNDEFINED_PARAM_ERROR:
		pszWork = "kCAM_IFCARD_UNDEFINED_PARAM_ERROR";
		break;
	case kCAM_IFCARD_CONFIGURATION_NOT_COMPLETED:
		pszWork = "kCAM_IFCARD_CONFIGURATION_NOT_COMPLETED";
		break;
	case kCAM_CAMARA_FROM1_VERITY_ERROR:
		pszWork = "kCAM_CAMARA_FROM1_VERITY_ERROR";
		break;
	case kCAM_CAMARA_FROM2_VERITY_ERROR:
		pszWork = "kCAM_CAMARA_FROM2_VERITY_ERROR";
		break;
	/// ?pc?ɊւG?
	case kCAM_EST_CANNOT_GET_DEVICE_VERSION:
		pszWork = "kCAM_EST_CANNOT_GET_DEVICE_VERSION";
		break;
	case kCAM_EST_CANNOT_SET_DEVICE_SERIAL_NUMBER:
		pszWork = "kCAM_EST_CANNOT_SET_DEVICE_SERIAL_NUMBER";
		break;
	case kCAM_EST_CANNOT_GET_DEVICE_SERIAL_NUMBER:
		pszWork = "kCAM_EST_CANNOT_GET_DEVICE_SERIAL_NUMBER";
		break;
	case kCAM_EST_CANNOT_SET_DEVICE_DEBUG_REG:
		pszWork = "kCAM_EST_CANNOT_SET_DEVICE_DEBUG_REG";
		break;
	case kCAM_EST_CANNOT_GET_DEVICE_DEBUG_REG:
		pszWork = "kCAM_EST_CANNOT_GET_DEVICE_DEBUG_REG";
		break;
	case kCAM_EST_INVALID_DEVICE_ID:
		pszWork = "kCAM_EST_INVALID_DEVICE_ID";
		break;
	case kCAM_EST_ERROR_DATAWRITE:
		pszWork = "kCAM_EST_ERROR_DATAWRITE";
		break;
	case kCAM_EST_INVALID_SHARPNESS_EFFECT:
		pszWork = "kCAM_EST_INVALID_SHARPNESS_EFFECT";
		break;
	case kCAM_EST_INVALID_TEMPERATURE_TYPE:
		pszWork = "kCAM_EST_INVALID_TEMPERATURE_TYPE";
		break;
	case kCAM_INVALID_CCD_TARGET_TEMPERATURE:
		pszWork = "kCAM_INVALID_CCD_TARGET_TEMPERATURE";
		break;
	/// Monte-Carlo
	case kCAM_INVALID_OPEN_DELAY:
		pszWork = "kCAM_INVALID_OPEN_DELAY";
		break;
	case kCAM_IP_INVALID_CUSTOM_BW_COEFFICIENT:
		pszWork = "kCAM_IP_INVALID_CUSTOM_BW_COEFFICIENT";
		break;
	case kCAM_CAMERA_HEAD_POWER_ERROR:
		pszWork = "kCAM_CAMERA_HEAD_POWER_ERROR";
		break;
	case kCAM_CAMERA_PELTIER_POWER_ERROR:
		pszWork = "kCAM_CAMERA_PELTIER_POWER_ERROR";
		break;
	case kCAM_SIA_INVALID_COLOR_MODE:
		pszWork = "kCAM_SIA_INVALID_COLOR_MODE";
		break;
	case kCAM_LV_INVALID_BYTES_A_CHANNEL:
		pszWork = "kCAM_LV_INVALID_BYTES_A_CHANNEL";
		break;
	case kCAM_LV_INVALID_SHIFT_BITS_FOR_16:
		pszWork = "kCAM_LV_INVALID_SHIFT_BITS_FOR_16";
		break;
	case kCAM_LV_INVALID_COLOR_MODE_AND_BYTES_A_CHANNEL:
		pszWork = "kCAM_LV_INVALID_COLOR_MODE_AND_BYTES_A_CHANNEL";
		break;
	case kCAM_CAMERA_ROM_ERASE_ERROR:
		pszWork = "kCAM_CAMERA_ROM_ERASE_ERROR";
		break;
	case kCAM_CAMERA_ROM_WRITE_ERROR:
		pszWork = "kCAM_CAMERA_ROM_WRITE_ERROR";
		break;
	case kCAM_CAMERA_FW_ERROR:
		pszWork = "kCAM_CAMERA_FW_ERROR";
		break;
	case kCAM_EST_INVALID_UPDATE_DATA:
		pszWork = "kCAM_EST_INVALID_UPDATE_DATA";
		break;
	case kCAM_CAMERA_OS_REBOOT:
		pszWork = "kCAM_CAMERA_OS_REBOOT";
		break;
	case kCAM_UPDATE_ERROR:
		pszWork = "kCAM_UPDATE_ERROR";
		break;
	case kCAM_LNK_COMMUNICATION_ERROR:
		pszWork = "kCAM_LNK_COMMUNICATION_ERROR";
		break;
	case kCAM_LNK_SEND_TIMEOUT:
		pszWork = "kCAM_LNK_SEND_TIMEOUT";
		break;
	case kCAM_IP_INVALID_COLOR_SPACE_MODE:
		pszWork = "kCAM_IP_INVALID_COLOR_SPACE_MODE";
		break;
	case kCAM_LNK_INVALID_SEND_SIZE:
		pszWork = "kCAM_LNK_INVALID_SEND_SIZE";
		break;
	case kCAM_LNK_INVALID_BAUDRATE:
		pszWork = "kCAM_LNK_INVALID_BAUDRATE";
		break;
	case kCAM_LNK_NO_DEVICE:
		pszWork = "kCAM_LNK_NO_DEVICE";
		break;
	case kCAM_LNK_UART_ERROR:
		pszWork = "kCAM_LNK_UART_ERROR";
		break;

	/// (ڍׂȃG?́A1000ԑ䂩X??g)
	/// JɊւڍ׃G?
	case kCAM_NO_DETAIL_ERROR:
		pszWork = "kCAM_NO_DETAIL_ERROR";
		break;
	/// Detail errors relate to library initialization.
	case kCAM_API_CANNOT_CREATE_CAMERA:
		pszWork = "kCAM_API_CANNOT_CREATE_CAMERA";
		break;
	case kCAM_API_CANNOT_CREATE_CAMERA_BOARD:
		pszWork = "kCAM_API_CANNOT_CREATE_CAMERA_BOARD";
		break;
	case kCAM_API_CANNOT_INITIALIZE_CAMERA_BOARD:
		pszWork = "kCAM_API_CANNOT_INITIALIZE_CAMERA_BOARD";
		break;
	case kCAM_API_CANNOT_CREATE_CAMERA_PARTS:
		pszWork = "kCAM_API_CANNOT_CREATE_CAMERA_PARTS";
		break;
	case kCAM_API_CANNOT_ALLOCATE_LUT:
		pszWork = "kCAM_API_CANNOT_ALLOCATE_LUT";
		break;
	case kCAM_API_CANNOT_ALLOCATE_DMA_TRANS_BUFFER:
		pszWork = "kCAM_API_CANNOT_ALLOCATE_DMA_TRANS_BUFFER";
		break;
	case kCAM_API_CANNOT_LOCK_DMA_TRANS_BUFFER:
		pszWork = "kCAM_API_CANNOT_LOCK_DMA_TRANS_BUFFER";
		break;
	/// Detail errors relate to the recoder.
	case kCAM_API_CANNOT_ALLOCATE_CACHE:
		pszWork = "kCAM_API_CANNOT_ALLOCATE_CACHE";
		break;
	/// Detail errors relate to the camera.
	case kCAM_CAMERA_DEVICE_AFE_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_AFE_ERROR";
		break;
	case kCAM_CAMERA_DEVICE_TG_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_TG_ERROR";
		break;
	case kCAM_CAMERA_DEVICE_EEPROM_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_EEPROM_ERROR";
		break;
	case kCAM_CAMERA_DEVICE_ADC_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_ADC_ERROR";
		break;
	case kCAM_CAMERA_DEVICE_DAC_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_DAC_ERROR";
		break;
	case kCAM_CAMERA_DEVICE_OTHER_ERROR:
		pszWork = "kCAM_CAMERA_DEVICE_OTHER_ERROR";
		break;
	/// PCI??hɊւڍ׃G?
	case kCAM_IFCARD_DEVICE_EEPROM_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_EEPROM_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_FLASH_ROM_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_FLASH_ROM_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_SDRAM_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_SDRAM_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_FIFO_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_FIFO_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_BANK_MEMORY_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_BANK_MEMORY_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_SDRAMC_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_SDRAMC_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_DIP1_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_DIP1_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_DIP2_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_DIP2_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_OTHER_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_OTHER_ERROR";
		break;
	/// PCI??h̃RtBO?VɊւڍ׃G?
	case kCAM_IFCARD_CONFIG_SDRAMC_ERROR:
		pszWork = "kCAM_IFCARD_CONFIG_SDRAMC_ERROR";
		break;
	case kCAM_IFCARD_CONFIG_DIP1_ERROR:
		pszWork = "kCAM_IFCARD_CONFIG_DIP1_ERROR";
		break;
	case kCAM_IFCARD_CONFIG_DIP2_ERROR:
		pszWork = "kCAM_IFCARD_CONFIG_DIP2_ERROR";
		break;
	case kCAM_IFCARD_CONFIG_OTHER_ERROR:
		pszWork = "kCAM_IFCARD_CONFIG_OTHER_ERROR";
		break;
	case kCAM_IFCARD_DEVICE_CAMERA_ERROR:
		pszWork = "kCAM_IFCARD_DEVICE_CAMERA_ERROR";
		break;

	/// (x́A10000ԑ䂩X??g)
	/// x
	case kCAM_CANNOT_READ_DEFAULT_LUT:
		pszWork = "kCAM_CANNOT_READ_DEFAULT_LUT";
		break;
	case kCAM_INVALID_DEFAULT_LUT:
		pszWork = "kCAM_INVALID_DEFAULT_LUT";
		break;
	case kCAM_LV_MISSED_FRAME:
		pszWork = "kCAM_LV_MISSED_FRAME";
		break;
	case kCAM_LV_INVALID_FRAME:
		pszWork = "kCAM_LV_INVALID_FRAME";
		break;
	default:
		return FALSE;
	}
	strncpy_s(pszName, dwLength, pszWork, _TRUNCATE);
	assert(strlen(pszName) < MAX_NAME_LENGTH);

	return TRUE;
}

BOOL CErrorLookupDP::GetDescription(CAM_ERROR kErrorCode, char *pszName, DWORD dwLength,
									LANGUAGE kLanguage/* = JAPANESE*/) const
{
	assert(MAX_NORMAL_ERROR	== kCAM_LNK_UART_ERROR);
	assert(MAX_DETAIL_ERROR	== kCAM_IFCARD_DEVICE_CAMERA_ERROR);
	assert(MAX_WARNING == kCAM_LV_INVALID_FRAME);

	char *pszWork = 0;

	switch (kLanguage)
	{
	case JAPANESE:



	switch (kErrorCode)
	{
	case kCAM_NO_ERROR:
		pszWork = "G?Ȃ";
		break;
	case kCAM_API_INVALID_OBJECT:
		pszWork = "sȃJIuWFNg";
		break;
	case kCAM_API_INVALID_PARAM:
		pszWork = "ȃp??";
		break;
	case kCAM_API_PARAM_OUT_OF_RANGE:
		pszWork = "p??͈͊O";
		break;
	case kCAM_API_CALLED_IN_INVALID_STATE:
		pszWork = "֐́As?ȂƂɌĂ΂ꂽ";
		break;
	case kCAM_API_LIB_INITIALIZE_ERROR:
		pszWork = "CuG?";
		break;
	case kCAM_API_INTERNAL_ERROR:
		pszWork = "CuG?";
		break;
	case kCAM_WRONG_SYNCHRONIZED_MODE:
		pszWork = "w肳ꂽ܂́A񓯊?h̓T??gĂȂ";
		break;
	case kCAM_WINAPI_ERROR:
		pszWork = "Windows APIɊւG?";
		break;
	case kCAM_WINAPI_CANNOT_START_TIMEOUT_TIMER:
		pszWork = "?C?AEgʒmp?C??̍쐬Ɏs";
		break;
	case kCAM_NOT_SUPPORTED:
		pszWork = "T??gĂȂ֐Ăяo";
		break;
	/// JԂ̃ZbgAbvɊւG?
	case kCAM_API_OBJECT_ALREADY_CREATED:
		pszWork = "ɃJIuWFNg͍쐬Ă";
		break;
	case kCAM_INVALID_CAMERA_ID:
		pszWork = "sȃJID";
		break;
	case kCAM_CANNOT_COPY_ENUMERATED_CAMERA_ID:
		pszWork = "SẴJIDw肳ꂽobt?ɃRs?邱ƂłȂ";
		break;
	case kCAM_INVALID_CAMERA_MODE:
		pszWork = "sȃJ?h";
		break;
	case kCAM_INVALID_CALLBACK_ID:
		pszWork = "sȃR?obNID";
		break;
	case kCAM_INVALID_ERROR:
		pszWork = "sȃG?R?h";
		break;
	case kCAM_INVALID_CALLBACK_FUNC:
		pszWork = "R?obN֐si==NULLj";
		break;
	case kCAM_NO_CALLBACK_FUNC:
		pszWork = "R?obN֐s";
		break;
	case kCAM_INITIALIZE_TIMEOUT:
		pszWork = "?C?AEg";
		break;
	case kCAM_INVALID_POWER_STATE:
		pszWork = "sȃJd";
		break;
	case kCAM_ALREADY_POWER_STATE_SET:
		pszWork = "w肵dԂ͊ɐݒ肳Ă";
		break;
	case kCAM_INVALID_TIMEOUT:
		pszWork = "s?C?AEgw肵";
		break;
	case kCAM_INVALID_LIGHT_PATH_SHUTTER_STATE:
		pszWork = "sȃVb?Ԃw肵A삪?C?AEg";
		break;
	/// IoɊւG?
	case kCAM_AE_INVALID_ADJUSTMENT_PARAM:
		pszWork = "Io␳ls";
		break;
	case kCAM_AE_INVALID_EVAL_FUNC:
		pszWork = "s?֐";
		break;
	case kCAM_AE_INVALID_REGION:
		pszWork = "sȑ̈";
		break;
	case kCAM_AE_INVALID_LOCK_STATE:
		pszWork = "AEbN?hs";
		break;
	case kCAM_AE_INVALID_TARGET_VALUE:
		pszWork = "AEڕWls";
		break;
	case kCAM_AE_ALREADY_LOCK_STATE_SET:
		pszWork = "ɐݒ肳Ă郍bNԂ̍Đݒ";
		break;
	case kCAM_AE_NO_EVAL_FUNC:
		pszWork = "AE?֐o?ĂȂ";
		break;
	case kCAM_EXP_AE_NORMAL_ONETIME_TIMEOUT:
		pszWork = "?C?AE?C?AEgiKIoɂȂȂj";
		break;
	case kCAM_EXP_AE_SFL_ONETIME_TIMEOUT:
		pszWork = "?C?SFL?C?AEg(KIoɂȂȂ)";
		break;
	/// IoɊւG?
	case kCAM_EXP_INVALID_MODE:
		pszWork = "sAE?h";
		break;
	case kCAM_EXP_INVALID_SHUTTER_SPEED:
		pszWork = "ݒs?ȃVb?";
		break;
	case kCAM_EXP_INVALID_ISO:
		pszWork = "ݒs?ISOl";
		break;
	case kCAM_EXP_INVALID_ISO_GAIN:
		pszWork = "sISOQCl";
		break;
	case kCAM_EXP_INVALID_GAINED_EXPOSURE_MODE:
		pszWork = "sȃQCIo?h";
		break;
	case kCAM_EXP_INVALID_CCD_SENSITIVITY_MODE:
		pszWork = "sCCDx";
		break;
	case kCAM_EXP_ALREADY_MODE_SET:
		pszWork = "ɐݒ肳ĂIo?hݒ肵";
		break;
	case kCAM_EXP_INVALID_APPROPRIATEEXPCOUNT:
		pszWork = "sȓKؘIoo";
		break;
	case kCAM_EXP_INVALID_ONETIME_TIMEOUT:
		pszWork = "sOneTime-AE?C?AEg";
		break;
	case kCAM_EXP_INVALID_REAL_EXPOSURE_LIMIT:
		pszWork = "sȎIoԏ";
		break;

	/// tH?JXɊւG?
	case kCAM_FCS_INVALID_FOCUSMODE:
		pszWork = "tH?JX?hs";
		break;
	case kCAM_FCS_INVALID_REGION:
		pszWork = "tH?JẌs";
		break;
	/// WBɊւG?
	case kCAM_WB_CALIBRATE_ERROR:
		pszWork = "WBvZs(vZʂ͈͊O0Z)";
		break;
	case kCAM_WB_CALIBRATE_TIMEOUT:	
		pszWork = "WB?C?AEg";
		break;
	case kCAM_WB_INVALID_MODE:
		pszWork = "WB?hs";
		break;
	case kCAM_WB_INVALID_REGION:
		pszWork = "ݒs?WB̈";
		break;
	case kCAM_WB_INVALID_GAIN:
		pszWork = "ݒs?RGBQC";
		break;
	case kCAM_WB_CANNOT_SET_SPECIFIED_WB:
		pszWork = "w肵WB͐ݒłȂ";
		break;
	/// BBɊւG?
	case kCAM_BB_CALIBRATE_ERROR:
		pszWork = "BBvZs(vZʂ͈͊O0Z)";
		break;
	case kCAM_BB_CALIBRATE_TIMEOUT:
		pszWork = "BB?C?AEg";
		break;
	case kCAM_BB_INVALID_MODE:
		pszWork = "BB?hs";
		break;
	case kCAM_BB_INVALID_REGION:
		pszWork = "ݒs?BB̈";
		break;
	case kCAM_BB_INVALID_OFFSET:
		pszWork = "ݒs?RGBItZbgl";
		break;
	/// 摜ɊւG?
	case kCAM_IP_INVALID_ORIENTATION:
		pszWork = "sȉ摜";
		break;
	case kCAM_IP_INVALID_SHARPNESS:
		pszWork = "sȃV?vlX";
		break;
	case kCAM_IP_INVALID_COLOR_MODE:
		pszWork = "sȃJ??h";
		break;
	case kCAM_IP_INVALID_LEVEL_ADJUST:
		pszWork = "sȃx␳p??";
		break;
	case kCAM_IP_INVALID_LUT:
		pszWork = "LUTs";
		break;
	case kCAM_IP_INVALID_DARK_IMAGE_TIMES:
		pszWork = "s??NBe";
		break;
	case kCAM_IP_INVALID_NOISE_REDUCTION:
		pszWork = "sȃmCY?NV?h";
		break;
	/// ɊւG?
	case kCAM_LV_INVALID_IMAGE_SIZE:
		pszWork = "s摜TCY";
		break;
	case kCAM_LV_INVALID_BINNING_MODE:
		pszWork = "rjO?hG?";
		break;
	case kCAM_LV_CANNOT_SET_SPECIFIED_BINNING_MODE:
		pszWork = "݂̃?hł͎w肵rjO?h͐ݒłȂBY??2x̂ƂA2x2, 4x4̃rjOw肳ꂽ";
		break;
	case kCAM_LV_INVALID_ZOOM:
		pszWork = "Y???G?";
		break;
	case kCAM_LV_INVALID_ZOOM_REGION:
		pszWork = "sȃY??̈";
		break;
	case kCAM_LV_CANNOT_SET_SPECIFIED_ZOOM:
		pszWork = "݂̃?hł̓Y??͎włȂBrjO2x2, 4x4,8x8̂ƂɁAY??w肵";
		break;
	case kCAM_LV_INVALID_CCD_IMAGE_TYPE:
		pszWork = "CCD摜?Cv(Bayer/W?)Ă";
		break;
	case kCAM_LV_MOVIE_ERROR:
		pszWork = "摜G?B摜擾ɃG?";
		break;
	case kCAM_LV_MOVIE_TIMEOUT:
		pszWork = "擾?C?AEg";
		break;
	case kCAM_LV_INVALID_BIT_A_PIXEL:
		pszWork = "s1frbg";
		break;
	/// L?ɊւG?
	case kCAM_REC_START_ERROR:
		pszWork = "?JnG??t?CI?vłȂBł?撆ɂȂĂ";
		break;
	case kCAM_REC_STOP_ERROR:
		pszWork = "??G?";
		break;
	case kCAM_REC_LACK_OF_MEMORY:
		pszWork = "?ɕKvȃmۂłȂ";
		break;
	case kCAM_REC_INVALID_FILENAME:
		pszWork = "?t?Cs?t???bgɑΉgqĂȂBtpX255ȏɂȂĂ";
		break;
	case kCAM_REC_INVALID_TRIMMINGREGION:
		pszWork = "?g?ÖG?vr?͈͊OɃg?Öݒ肵Ă(Y??XN?̌)B̈悪";
		break;
	case kCAM_REC_INVALID_FORMAT:
		pszWork = "?tH??bgs";
		break;
	case kCAM_REC_INVALID_FRAMETIME:
		pszWork = "Đ̂Pt??̎Ԃs";
		break;
	/// ?ɊւG?
	case kCAM_SIA_INVALID_PRECAPTUE_MODE:
		pszWork = "sȃvLv???h";
		break;
	case kCAM_SIA_INVALID_ACCUMULATE_MODE:
		pszWork = "sȐώZ?h";
		break;
	case kCAM_SIA_INVALID_ACCUMULATE_TIMES:
		pszWork = "sȐώZ";
		break;
	case kCAM_SIA_INVALID_BYTES_A_CHANNEL:
		pszWork = "sȂP?l̃oCg";
		break;
	case kCAM_SIA_INVALID_SHIFT_BITS_FOR_16:
		pszWork = "sȐ?摜f??Vtg";
		break;
	case kCAM_SIA_INVALID_IMAGE_SIZE:
		pszWork = "ݒsȉ摜TCY";
		break;
	case kCAM_SIA_CANNOT_SET_SPECIFIED_IMAGE_SIZE:
		pszWork = "?rjOƂ̊֌WŐݒs̉摜TCY";
		break;
	case kCAM_SIA_INVALID_BINNING_MODE:
		pszWork = "sȐ?摜rjO?h";
		break;
	case kCAM_SIA_CANNOT_SET_SPECIFIED_BINNING_MODE:
		pszWork = "摜TCYƂ̊֌WŐݒs̐?摜rjO?h";
		break;
	case kCAM_SIA_INVALID_TRIMMING_REGION:
		pszWork = "sȃg?Ö";
		break;
	case kCAM_SIA_CANNOT_CAPTURE:
		pszWork = "?摜擾łȂ";
		break;
	case kCAM_SIA_CANNOT_STOP:
		pszWork = "?擾rIłȂ";
		break;
	case kCAM_SIA_CANNOT_GET_PROGRESS:
		pszWork = "?摜擾Ԃ擾łȂ";
		break;
	case kCAM_SIA_INVALID_CCD_IMAGE_TYPE:
		pszWork = "CCD̃C?W?Cvsł";
		break;
	case kCAM_SIA_CAPTURE_ERROR:
		pszWork = "?擾s";
		break;
	case kCAM_SIA_CAPTURE_TIMEOUT:
		pszWork = "?擾?C?AEg";
		break;
	case kCAM_SIA_INVALID_NOISE_REDUCTION_MODE:
		pszWork = "sȃmCY?NV?h";
		break;
	/// ʐMɊւG?
	case kCAM_COM_INVALID_COMMAND:
		pszWork = "R?h";
		break;
	case kCAM_COM_INVALID_INTERRUPT:
		pszWork = "ݗv";
		break;
	case kCAM_COM_INVALID_PARAMETER:
		pszWork = "p??if??j";
		break;
	case kCAM_COM_PARAM_OUT_OF_RANGE:
		pszWork = "͈͊Op??";
		break;
	case kCAM_COM_INVALID_MEMORY_ADDRESS:
		pszWork = "AhX";
		break;
	case kCAM_COM_TIMEOUT:
		pszWork = "ʐM?C?AEg";
		break;
	case kCAM_IFCARD_COMMINUCATION_ERROR: ///< xxx Ԃ?X?
		pszWork = "(PCI)I/FJ?hʐMXe??XG?";
		break;
	case kCAM_COM_BUFFER_FULL:
		pszWork = "(PCI)I/FJ?h̒ʐMp̃R?hobt?ςɂȂ";
		break;
	/// JɊւG?
	case kCAM_CAMERA_ERROR:
		pszWork = "J̃G?";
		break;
	case kCAM_CAMERA_NOHEAD:
		pszWork = "Jwbhڑ";
		break;
	case kCAM_CAMERA_WRONG_HEAD:
		pszWork = "?JwbhڑJIDG?";
		break;
	case kCAM_CCD_HOT_WARNING:
		pszWork = "CCDُ";
		break;
	case kCAM_CCD_COOL_WARNING:
		pszWork = "CCDቷُ";
		break;
	case kCAM_CCD_COOL_CAUTION:
		pszWork = "CCDߗp";
		break;
	case kCAM_HOT_WARNING:
		pszWork = "Jُ픭M";
		break;
	case kCAM_COOL_WARNING:
		pszWork = "Jُp";
		break;
	case kCAM_CAMERA_DEVICE_ERROR:
		pszWork = "JfoCXُ";
		break;
	case kCAM_CAMERA_POWER_ERROR:
		pszWork = "Jdُ";
		break;
	case KCAM_CAMERA_NO_CAMPS:
		pszWork = "CAMPS??hڑ";
		break;
	case kCAM_LIGHTPATH_SHUTTER_DEVICE_ERROR:
		pszWork = "JH̃Vb?̊JŃG?";
		break;
	case kCAM_CAMERA_CASE_HOT_WARNING:
		pszWork = "JP?Xُ";
		break;
	/// PCI??hɊւG?
	case kCAM_IFCARD_ERROR:
		pszWork = "(PCI) I/FJ?hG?";
		break;
	case kCAM_IFCARD_DEVICE_ERROR:
		pszWork = "(PCI)I/FJ?hfoCXG?";
		break;
	case kCAM_IFCARD_CONFIGURATION_ERROR:
		pszWork = "(PCI)I/FJ?hRtBO?VG?";
		break;
	case kCAM_IFCARD_UNDEFINED_PARAM_ERROR:
		pszWork = "(PCI)I/FJ?h?p??";
		break;
	case kCAM_IFCARD_CONFIGURATION_NOT_COMPLETED:
		pszWork = "(PCI)I/FJ?h̃RtBO?VĂȂ";
		break;
	case kCAM_CAMARA_FROM1_VERITY_ERROR:
		pszWork = "(Jwbh)EEPROM݃G?";
		break;
	case kCAM_CAMARA_FROM2_VERITY_ERROR:
		pszWork = "(Jwbh)EEPROM݃G?";
		break;
	/// ?pc?ɊւG?
	case kCAM_EST_CANNOT_GET_DEVICE_VERSION:
		pszWork = "foCXo?W擾łȂ";
		break;
	case kCAM_EST_CANNOT_SET_DEVICE_SERIAL_NUMBER:
		pszWork = "VAԍݒłȂ";
		break;
	case kCAM_EST_CANNOT_GET_DEVICE_SERIAL_NUMBER:
		pszWork = "VAԍ擾łȂ";
		break;
	case kCAM_EST_CANNOT_SET_DEVICE_DEBUG_REG:
		pszWork = "WX?ɒl߂ȂBJdOFFԂŁAwfoCXJwbh̃foCXꍇȂ";
		break;
	case kCAM_EST_CANNOT_GET_DEVICE_DEBUG_REG:
		pszWork = "WX?l擾łȂBJdOFFԂŁAwfoCXJwbh̃foCXꍇȂ";
		break;
	case kCAM_EST_INVALID_DEVICE_ID:
		pszWork = "ȃfoCXID";
		break;
	case kCAM_EST_ERROR_DATAWRITE:
		pszWork = "f??݃G?";
		break;
	case kCAM_EST_INVALID_SHARPNESS_EFFECT:
		pszWork = "sȃV?vlXxl";
		break;
	case kCAM_EST_INVALID_TEMPERATURE_TYPE:
		pszWork = "ȉx";
		break;
	case kCAM_INVALID_CCD_TARGET_TEMPERATURE:
		pszWork = "sCCDڕWx";
		break;
	/// Monte-Carlo
	case kCAM_INVALID_OPEN_DELAY:
		pszWork = "sȊOgKo̓I?vfBC";
		break;
	case kCAM_IP_INVALID_CUSTOM_BW_COEFFICIENT:
		pszWork = "sȓꃂmN?hW";
		break;
	case kCAM_CAMERA_HEAD_POWER_ERROR:
		pszWork = "Jwbhdڑ";
		break;
	case kCAM_CAMERA_PELTIER_POWER_ERROR:
		pszWork = "y?Fdڑ";
		break;
	case kCAM_SIA_INVALID_COLOR_MODE:
		pszWork = "?擾łȂJ??hł";
		break;
	case kCAM_LV_INVALID_BYTES_A_CHANNEL:
		pszWork = "sȂP?l̃oCg";
		break;
	case kCAM_LV_INVALID_SHIFT_BITS_FOR_16:
		pszWork = "sȐ?摜f??Vtg";
		break;
	case kCAM_LV_INVALID_COLOR_MODE_AND_BYTES_A_CHANNEL:
		pszWork = "sȃJ??hƓ摜Pf̂Pch̃oCg̑gݍ킹";
		break;
	case kCAM_CAMERA_ROM_ERASE_ERROR:
		pszWork = "ROMAbvf?gΏۗ̈̏G?";
		break;
	case kCAM_CAMERA_ROM_WRITE_ERROR:
		pszWork = "ROMAbvf?gΏۗ̈ւ̏G?";
		break;
	case kCAM_CAMERA_FW_ERROR:
		pszWork = "ROMF/WAv̈悪ُ̏ꍇ";
		break;
	case kCAM_EST_INVALID_UPDATE_DATA:
		pszWork = "sȃAbvf?gf??";
		break;
	case kCAM_CAMERA_OS_REBOOT:
		pszWork = "Abvf?g̍ċNsG?";
		break;
	case kCAM_UPDATE_ERROR:
		pszWork = "Abvf?gĂȂ";
		break;
	case kCAM_LNK_COMMUNICATION_ERROR:
		pszWork = "DPLinkʐMG?";
		break;
	case kCAM_LNK_SEND_TIMEOUT:
		pszWork = "DPLinkM?C?AEgG?";
		break;
	case kCAM_IP_INVALID_COLOR_SPACE_MODE:
		pszWork = "sȐFԃ?h";
		break;
	case kCAM_LNK_INVALID_SEND_SIZE:
		pszWork = "sDPLinkMTCY";
		break;
	case kCAM_LNK_INVALID_BAUDRATE:
		pszWork = "sDPLink???g";
		break;
	case kCAM_LNK_NO_DEVICE:
		pszWork = "DPLinkfoCXoG?";
		break;
	case kCAM_LNK_UART_ERROR:
		pszWork = "DPLink UARTʐMG?";
		break;

	/// (ڍׂȃG?́A1000ԑ䂩X??g)
	/// JɊւڍ׃G?
	case kCAM_NO_DETAIL_ERROR:
		pszWork = "ڍ׃G?͂Ȃ";
		break;
	/// Detail errors relate to library initialization.
	case kCAM_API_CANNOT_CREATE_CAMERA:
		pszWork = "JiIuWFNgs";
		break;
	case kCAM_API_CANNOT_CREATE_CAMERA_BOARD:
		pszWork = "J??hIuWFNgsG?";
		break;
	case kCAM_API_CANNOT_INITIALIZE_CAMERA_BOARD:
		pszWork = "J??hs";
		break;
	case kCAM_API_CANNOT_CREATE_CAMERA_PARTS:
		pszWork = "JiIuWFNgs";
		break;
	case kCAM_API_CANNOT_ALLOCATE_LUT:
		pszWork = "LUT̈mێs";
		break;
	case kCAM_API_CANNOT_ALLOCATE_DMA_TRANS_BUFFER:
		pszWork = "DMA?obt?̈mێs";
		break;
	case kCAM_API_CANNOT_LOCK_DMA_TRANS_BUFFER:
		pszWork = "DMA?obt?̈惍bNs";
		break;
	/// Detail errors relate to the recoder.
	case kCAM_API_CANNOT_ALLOCATE_CACHE:
		pszWork = "?obt?mۂłȂ";
		break;
	/// Detail errors relate to the camera.
	case kCAM_CAMERA_DEVICE_AFE_ERROR:
		pszWork = "AFEُ";
		break;
	case kCAM_CAMERA_DEVICE_TG_ERROR:
		pszWork = "TGُ";
		break;
	case kCAM_CAMERA_DEVICE_EEPROM_ERROR:
		pszWork = "EEPROMُ";
		break;
	case kCAM_CAMERA_DEVICE_ADC_ERROR:
		pszWork = "ADCُ";
		break;
	case kCAM_CAMERA_DEVICE_DAC_ERROR:
		pszWork = "DACُ";
		break;
	case kCAM_CAMERA_DEVICE_OTHER_ERROR:
		pszWork = "foCXُ";
		break;
	/// PCI??hɊւڍ׃G?
	case kCAM_IFCARD_DEVICE_EEPROM_ERROR:
		pszWork = "EEPROMُ";
		break;
	case kCAM_IFCARD_DEVICE_FLASH_ROM_ERROR:
		pszWork = "tbVROMُ";
		break;
	case kCAM_IFCARD_DEVICE_SDRAM_ERROR:
		pszWork = "SDRAMG?";
		break;
	case kCAM_IFCARD_DEVICE_FIFO_ERROR:
		pszWork = "FIFOG?";
		break;
	case kCAM_IFCARD_DEVICE_BANK_MEMORY_ERROR:
		pszWork = "oNG?";
		break;
	case kCAM_IFCARD_DEVICE_SDRAMC_ERROR:
		pszWork = "SDRAMCG?";
		break;
	case kCAM_IFCARD_DEVICE_DIP1_ERROR:
		pszWork = "DIP1G?";
		break;
	case kCAM_IFCARD_DEVICE_DIP2_ERROR:
		pszWork = "DIP2G?";
		break;
	case kCAM_IFCARD_DEVICE_OTHER_ERROR:
		pszWork = "foCXُ";
		break;
	/// PCI??h̃RtBO?VɊւڍ׃G?
	case kCAM_IFCARD_CONFIG_SDRAMC_ERROR:
		pszWork = "SDRAMCRtBO?Vs";
		break;
	case kCAM_IFCARD_CONFIG_DIP1_ERROR:
		pszWork = "DIP1RtBO?Vs";
		break;
	case kCAM_IFCARD_CONFIG_DIP2_ERROR:
		pszWork = "DIP2RtBO?Vs";
		break;
	case kCAM_IFCARD_CONFIG_OTHER_ERROR:
		pszWork = "FPGÃRtBO?VG?";
		break;
	case kCAM_IFCARD_DEVICE_CAMERA_ERROR:
		pszWork = "(PCI/Jwbh) RtBO?VG?";
		break;

	/// (x́A10000ԑ䂩X??g)
	/// x
	case kCAM_CANNOT_READ_DEFAULT_LUT:
		pszWork = "fBtHgLUTǂݍ݂Ɏs";
		break;
	case kCAM_INVALID_DEFAULT_LUT:
		pszWork = "LUTǂݍݒlُ";
		break;
	case kCAM_LV_MISSED_FRAME:
		pszWork = "t??̎肱ڂ";
		break;
	case kCAM_LV_INVALID_FRAME:
		pszWork = "擾t??͕sł";
		break;
	default:
		return FALSE;
	}



		break;
	case ENGLISH:



	switch (kErrorCode)
	{
	case kCAM_NO_ERROR:
		pszWork = "No error.";
		break;
	case kCAM_API_INVALID_OBJECT:
		pszWork = "Camera object invalid.";
		break;
	case kCAM_API_INVALID_PARAM:
		pszWork = "Parameter invalid.";
		break;
	case kCAM_API_PARAM_OUT_OF_RANGE:
		pszWork = "Parameter out of range.";
		break;
	case kCAM_API_CALLED_IN_INVALID_STATE:
		pszWork = "Function called while its execution is impossible.";
		break;
	case kCAM_API_LIB_INITIALIZE_ERROR:
		pszWork = "Library initialization error.";
		break;
	case kCAM_API_INTERNAL_ERROR:
		pszWork = "Library internal error.";
		break;
	case kCAM_WRONG_SYNCHRONIZED_MODE:
		pszWork = "The specified sync or async mode is not supported.";
		break;
	case kCAM_WINAPI_ERROR:
		pszWork = "A Windows API-related error occurred.";
		break;
	case kCAM_WINAPI_CANNOT_START_TIMEOUT_TIMER:
pszWork = "It failed in making the timer for the time-out notification. ";
		break;
	case kCAM_NOT_SUPPORTED:
		pszWork = "The called function is not supported.";
		break;
	/// JԂ̃ZbgAbvɊւG?
	case kCAM_API_OBJECT_ALREADY_CREATED:
		pszWork = "The camera object has already been created.";
		break;
	case kCAM_INVALID_CAMERA_ID:
		pszWork = "Camera ID invalid.";
		break;
	case kCAM_CANNOT_COPY_ENUMERATED_CAMERA_ID:
		pszWork = "All of the camera IDs failed to be copied in the specified character buffer.";
		break;
	case kCAM_INVALID_CAMERA_MODE:
		pszWork = "Camera mode invalid.";
		break;
	case kCAM_INVALID_CALLBACK_ID:
		pszWork = "Callback ID invalid.";
		break;
	case kCAM_INVALID_ERROR:
		pszWork = "Error code invalid.";
		break;
	case kCAM_INVALID_CALLBACK_FUNC:
		pszWork = "Callback function invalid (== NULL)";
		break;
	case kCAM_NO_CALLBACK_FUNC:
		pszWork = "Callback function unknown.";
		break;
	case kCAM_INITIALIZE_TIMEOUT:
		pszWork = "Initialization time-out.";
		break;
	case kCAM_INVALID_POWER_STATE:
		pszWork = "Camera power state invalid.";
		break;
	case kCAM_ALREADY_POWER_STATE_SET:
		pszWork = "The specified power state is already set.";
		break;
	case kCAM_INVALID_TIMEOUT:
		pszWork = "The specified time-out is invalid.";
		break;
	case kCAM_INVALID_LIGHT_PATH_SHUTTER_STATE:
pszWork = "Operation did the time-out. whether to have specified an illegal state of the shutter.";
		break;
	/// IoɊւG?
	case kCAM_AE_INVALID_ADJUSTMENT_PARAM:
		pszWork = "Exposure adjustment parameter invalid.";
		break;
	case kCAM_AE_INVALID_EVAL_FUNC:
		pszWork = "Evaluation function invalid.";
		break;
	case kCAM_AE_INVALID_REGION:
		pszWork = "Metering region invalid.";
		break;
	case kCAM_AE_INVALID_LOCK_STATE:
		pszWork = "AE lock mode invalid.";
		break;
	case kCAM_AE_INVALID_TARGET_VALUE:
		pszWork = "AE target value invalid.";
		break;
	case kCAM_AE_ALREADY_LOCK_STATE_SET:
		pszWork = "The-set lock state is already set.";
		break;
	case kCAM_AE_NO_EVAL_FUNC:
		pszWork = "AF evaluation function not registered.";
		break;
	case kCAM_EXP_AE_NORMAL_ONETIME_TIMEOUT:
		pszWork = "Time-out during OneTime AE.(Appropriate exposure not obtained.)";
		break;
	case kCAM_EXP_AE_SFL_ONETIME_TIMEOUT:
		pszWork = "Time-out during OneTime SFL.(Appropriate exposure not obtained.)";
		break;
	/// IoɊւG?
	case kCAM_EXP_INVALID_MODE:
		pszWork = "AE mode invalid.";
		break;
	case kCAM_EXP_INVALID_SHUTTER_SPEED:
		pszWork = "Shutter speed invalid.";
		break;
	case kCAM_EXP_INVALID_ISO:
		pszWork = "ISO value invalid.";
		break;
	case kCAM_EXP_INVALID_ISO_GAIN:
		pszWork = "ISO gain value invalid.";
		break;
	case kCAM_EXP_INVALID_GAINED_EXPOSURE_MODE:
pszWork = "Illegal gained exposure mode";
		break;
	case kCAM_EXP_INVALID_CCD_SENSITIVITY_MODE:
		pszWork = "CCD sensitivity invalid.";
		break;
	case kCAM_EXP_ALREADY_MODE_SET:
		pszWork = "The set exposure mode is already set.";
		break;
	case kCAM_EXP_INVALID_APPROPRIATEEXPCOUNT:
		pszWork = "Appropriate exposure detection count invalid.";
		break;
	case kCAM_EXP_INVALID_ONETIME_TIMEOUT:
		pszWork = "OneTime-AE time-out period invalid.";
		break;
	case kCAM_EXP_INVALID_REAL_EXPOSURE_LIMIT:
pszWork = "Illegal real exposure time upper bound.";
		break;

	/// tH?JXɊւG?
	case kCAM_FCS_INVALID_FOCUSMODE:
		pszWork = "Focusing mode invalid.";
		break;
	case kCAM_FCS_INVALID_REGION:
		pszWork = "Focusing region invalid.";
		break;
	/// WBɊւG?
	case kCAM_WB_CALIBRATE_ERROR:
		pszWork = "WB calibration failure.1. Computation result out of range.2. Division by 0.";
		break;
	case kCAM_WB_CALIBRATE_TIMEOUT:	
pszWork = "WB time-out.";
		break;
	case kCAM_WB_INVALID_MODE:
		pszWork = "WB mode invalid.";
		break;
	case kCAM_WB_INVALID_REGION:
		pszWork = "WB region invalid for setting.";
		break;
	case kCAM_WB_INVALID_GAIN:
		pszWork = "RGB gain invalid for setting.";
		break;
	case kCAM_WB_CANNOT_SET_SPECIFIED_WB:
		pszWork = "Specified WB cannot be set.";
		break;
	/// BBɊւG?
	case kCAM_BB_CALIBRATE_ERROR:
		pszWork = "BB calibration failure.1. Computation result out of range2. Division by 0.";
		break;
	case kCAM_BB_CALIBRATE_TIMEOUT:
pszWork = "BB time-out.";
		break;
	case kCAM_BB_INVALID_MODE:
		pszWork = "BB mode invalid.";
		break;
	case kCAM_BB_INVALID_REGION:
		pszWork = "BB region invalid for setting.";
		break;
	case kCAM_BB_INVALID_OFFSET:
		pszWork = "RGB offset value invalid for setting.";
		break;
	/// 摜ɊւG?
	case kCAM_IP_INVALID_ORIENTATION:
		pszWork = "Image orientation invalid.";
		break;
	case kCAM_IP_INVALID_SHARPNESS:
		pszWork = "Sharpness invalid.";
		break;
	case kCAM_IP_INVALID_COLOR_MODE:
		pszWork = "Color mode invalid.";
		break;
	case kCAM_IP_INVALID_LEVEL_ADJUST:
		pszWork = "Level adjustment parameter invalid.";
		break;
	case kCAM_IP_INVALID_LUT:
		pszWork = "LUT invalid.";
		break;
	case kCAM_IP_INVALID_DARK_IMAGE_TIMES:
		pszWork = "No. of dark shootings invalid.";
		break;
	case kCAM_IP_INVALID_NOISE_REDUCTION:
		pszWork = "Noise reduction mode invalid.";
		break;
	/// ɊւG?
	case kCAM_LV_INVALID_IMAGE_SIZE:
		pszWork = "Image size invalid.";
		break;
	case kCAM_LV_INVALID_BINNING_MODE:
		pszWork = "Binning mode error.";
		break;
	case kCAM_LV_CANNOT_SET_SPECIFIED_BINNING_MODE:
		pszWork = "Specified binning mode cannot be set in the current mode. 2x2 or 4x4 binning was specified while the zoom ratio is 2x.";
		break;
	case kCAM_LV_INVALID_ZOOM:
		pszWork = "Zoom ratio error.";
		break;
	case kCAM_LV_INVALID_ZOOM_REGION:
		pszWork = "Zooming region invalid.";
		break;
	case kCAM_LV_CANNOT_SET_SPECIFIED_ZOOM:
		pszWork = "Zooming cannot be specified in the current mode. Zooming was specified during 2x2 or 4x4 binning.";
		break;
	case kCAM_LV_INVALID_CCD_IMAGE_TYPE:
		pszWork = "CCD image type (Bayer standard) invalid.";
		break;
	case kCAM_LV_MOVIE_ERROR:
		pszWork = "Movie error. An error occurred in movie capturing.";
		break;
	case kCAM_LV_MOVIE_TIMEOUT:
		pszWork = "Movie capturing time-out.";
		break;
	case kCAM_LV_INVALID_BIT_A_PIXEL:
pszWork = "Illegal one-pixel bit length";
		break;
	/// L?ɊւG?
	case kCAM_REC_START_ERROR:
		pszWork = "Recording start error.The recording file cannot be opened or recording is already started.";
		break;
	case kCAM_REC_STOP_ERROR:
		pszWork = "Recording stop error.";
		break;
	case kCAM_REC_LACK_OF_MEMORY:
		pszWork = "Memory required for memory cannot be reserved.";
		break;
	case kCAM_REC_INVALID_FILENAME:
		pszWork = "Recording filename invalid.File extension does not match the recording format.";
		break;
	case kCAM_REC_INVALID_TRIMMINGREGION:
		pszWork = "Recording trimming region error.Trimming region is set outside the preview region (as a result of zooming or scrolling) or the trimming region is too small.";
		break;
	case kCAM_REC_INVALID_FORMAT:
pszWork = "The recording format is illegal.";
		break;
	case kCAM_REC_INVALID_FRAMETIME:
pszWork = "The time a frame when reproducing is illegal.";
		break;
	/// ?ɊւG?
	case kCAM_SIA_INVALID_PRECAPTUE_MODE:
		pszWork = "Pre-capture mode invalid.";
		break;
	case kCAM_SIA_INVALID_ACCUMULATE_MODE:
		pszWork = "Accumulation mode invalid.";
		break;
	case kCAM_SIA_INVALID_ACCUMULATE_TIMES:
		pszWork = "Accumulation count invalid.";
		break;
	case kCAM_SIA_INVALID_BYTES_A_CHANNEL:
		pszWork = "Bytes per channel invalid.";
		break;
	case kCAM_SIA_INVALID_SHIFT_BITS_FOR_16:
		pszWork = "Left shifting amount of still image data invalid.";
		break;
	case kCAM_SIA_INVALID_IMAGE_SIZE:
		pszWork = "Image size invalid for setting.";
		break;
	case kCAM_SIA_CANNOT_SET_SPECIFIED_IMAGE_SIZE:
pszWork = "It is an image size of not being possible to set it because of still picture Bining.";
		break;
	case kCAM_SIA_INVALID_BINNING_MODE:
pszWork = "Illegal still picture Bining mord.";
		break;
	case kCAM_SIA_CANNOT_SET_SPECIFIED_BINNING_MODE:
pszWork = "It is still picture Bining mord of not being possible to set it because of the image size.";
		break;
	case kCAM_SIA_INVALID_TRIMMING_REGION:
		pszWork = "Trimming region invalid.";
		break;
	case kCAM_SIA_CANNOT_CAPTURE:
		pszWork = "Still image capturing impossible.";
		break;
	case kCAM_SIA_CANNOT_STOP:
		pszWork = "Still image capturing cannot be stopped in the middle.";
		break;
	case kCAM_SIA_CANNOT_GET_PROGRESS:
		pszWork = "Still image capturing state cannot be acquired.";
		break;
	case kCAM_SIA_INVALID_CCD_IMAGE_TYPE:
		pszWork = "CCD image type invalid.";
		break;
	case kCAM_SIA_CAPTURE_ERROR:
		pszWork = "Still image capturing failure.";
		break;
	case kCAM_SIA_CAPTURE_TIMEOUT:
		pszWork = "Still image capturing time-out.";
		break;
	case kCAM_SIA_INVALID_NOISE_REDUCTION_MODE:
		pszWork = "Noise reduction mode invalid.";
		break;
	/// ʐMɊւG?
	case kCAM_COM_INVALID_COMMAND:
		pszWork = "Command invalid.";
		break;
	case kCAM_COM_INVALID_INTERRUPT:
		pszWork = "Interrupt factor invalid.";
		break;
	case kCAM_COM_INVALID_PARAMETER:
		pszWork = "Parameter invalid (data).";
		break;
	case kCAM_COM_PARAM_OUT_OF_RANGE:
		pszWork = "Parameter out of range.";
		break;
	case kCAM_COM_INVALID_MEMORY_ADDRESS:
		pszWork = "Address invalid.";
		break;
	case kCAM_COM_TIMEOUT:
		pszWork = "Communication time-out.";
		break;
	case kCAM_IFCARD_COMMINUCATION_ERROR: ///< xxx Ԃ?X?
pszWork = "(PCI)I/F card communication status error.";
		break;
	case kCAM_COM_BUFFER_FULL:
		pszWork = "(PCI) Command buffer for I/F card communication is full.";
		break;
	/// JɊւG?
	case kCAM_CAMERA_ERROR:
		pszWork = "Camera operation error.";
		break;
	case kCAM_CAMERA_NOHEAD:
		pszWork = "Camera head not connected.";
		break;
	case kCAM_CAMERA_WRONG_HEAD:
		pszWork = "Different camera head model connected. Camera ID error.";
		break;
	case kCAM_CCD_HOT_WARNING:
		pszWork = "CCD high-temperature warning.";
		break;
	case kCAM_CCD_COOL_WARNING:
		pszWork = "CCD low-temperature warning.";
		break;
	case kCAM_CCD_COOL_CAUTION:
		pszWork = "CCD excessive cooling.";
		break;
	case kCAM_HOT_WARNING:
		pszWork = "Camera abnormal heating.";
		break;
	case kCAM_COOL_WARNING:
		pszWork = "Camera abnormal cooling.";
		break;
	case kCAM_CAMERA_DEVICE_ERROR:
		pszWork = "Camera device error.";
		break;
	case kCAM_CAMERA_POWER_ERROR:
		pszWork = "Camera power error.";
		break;
	case KCAM_CAMERA_NO_CAMPS:
		pszWork = "CAMPS board not connected.";
		break;
	case kCAM_LIGHTPATH_SHUTTER_DEVICE_ERROR:
		pszWork = "Error occurred in camera light path shutter opening.";
		break;
	case kCAM_CAMERA_CASE_HOT_WARNING:
		pszWork = "Camera case hight temperature error.";
		break;
	/// PCI??hɊւG?
	case kCAM_IFCARD_ERROR:
		pszWork = "(PCI) I/F card operation error.";
		break;
	case kCAM_IFCARD_DEVICE_ERROR:
		pszWork = "(PCI) I/F card device error.";
		break;
	case kCAM_IFCARD_CONFIGURATION_ERROR:
		pszWork = "(PCI) I/F card configuration error.";
		break;
	case kCAM_IFCARD_UNDEFINED_PARAM_ERROR:
		pszWork = "(PCI) I/F card undefined parameter.";
		break;
	case kCAM_IFCARD_CONFIGURATION_NOT_COMPLETED:
		pszWork = "(PCI) I/F card configuration not completed.";
		break;
	case kCAM_CAMARA_FROM1_VERITY_ERROR:
		pszWork = "(Camera head) EEPROM write error.";
		break;
	case kCAM_CAMARA_FROM2_VERITY_ERROR:
		pszWork = "(Camera head) EEPROM write error.";
		break;
	/// ?pc?ɊւG?
	case kCAM_EST_CANNOT_GET_DEVICE_VERSION:
pszWork = "The device version was not able to be acquired.";
		break;
	case kCAM_EST_CANNOT_SET_DEVICE_SERIAL_NUMBER:
pszWork = "The serial number cannot be set.";
		break;
	case kCAM_EST_CANNOT_GET_DEVICE_SERIAL_NUMBER:
pszWork = "The serial number cannot be acquired.";
		break;
	case kCAM_EST_CANNOT_SET_DEVICE_DEBUG_REG:
pszWork = "The value cannot be written in the register. In the state of camera power supply OFF, a specified device is a device on the camera head etc.";
		break;
	case kCAM_EST_CANNOT_GET_DEVICE_DEBUG_REG:
pszWork = "The value cannot be acquired from the register. In the state of camera power supply OFF, a specified device is a device on the camera head etc.";
		break;
	case kCAM_EST_INVALID_DEVICE_ID:
pszWork = "Invalid device ID.";
		break;
	case kCAM_EST_ERROR_DATAWRITE:
pszWork = "Data writing error.";
		break;
	case kCAM_EST_INVALID_SHARPNESS_EFFECT:
pszWork = "Illegal Sharpness value.";
		break;
	case kCAM_EST_INVALID_TEMPERATURE_TYPE:
pszWork = "Invalid temperature kind.";
		break;
	case kCAM_INVALID_CCD_TARGET_TEMPERATURE:
pszWork = "Illegal CCD target temperatures.(diff)";
		break;
	/// Monte-Carlo
	case kCAM_INVALID_OPEN_DELAY:
pszWork = "Illegal external trigger output opening delay time.";
		break;
	case kCAM_IP_INVALID_CUSTOM_BW_COEFFICIENT:
pszWork = "Illegal, custom black and white mode coefficient.";
		break;
	case kCAM_CAMERA_HEAD_POWER_ERROR:
pszWork = "Camera head power supply unconnected state.";
		break;
	case kCAM_CAMERA_PELTIER_POWER_ERROR:
pszWork = "Peltier power supply unconnected state.";
		break;
	case kCAM_SIA_INVALID_COLOR_MODE:
pszWork = "It is a color mode that the still picture cannot be acquired.";
		break;
	case kCAM_LV_INVALID_BYTES_A_CHANNEL:
pszWork = "The number of bytes a channel is illegal.";
		break;
	case kCAM_LV_INVALID_SHIFT_BITS_FOR_16:
pszWork = "The still picture data left shift is illegal.";
		break;
	case kCAM_LV_INVALID_COLOR_MODE_AND_BYTES_A_CHANNEL:
pszWork = "Combination of illegal number of bytess for each 1ch for color mode and Movie one pixel.";
		break;
	case kCAM_CAMERA_ROM_ERASE_ERROR:
pszWork = "Deletion error in area for ROM update.";
		break;
	case kCAM_CAMERA_ROM_WRITE_ERROR:
pszWork = "Writing error in area for ROM update.";
		break;
	case kCAM_CAMERA_FW_ERROR:
pszWork = "The F/W application program area on ROM is abnormal.";
		break;
	case kCAM_EST_INVALID_UPDATE_DATA:
pszWork = "Illegal update data.";
		break;
	case kCAM_CAMERA_OS_REBOOT:
pszWork = "Reactivation unexecution after it updates it.";
		break;
	case kCAM_UPDATE_ERROR:
pszWork = "The update is not completed.";
		break;
	case kCAM_LNK_COMMUNICATION_ERROR:
		pszWork = "DPLink communication error.";
		break;
	case kCAM_LNK_SEND_TIMEOUT:
		pszWork = "DPLink time out error.";
		break;
	case kCAM_IP_INVALID_COLOR_SPACE_MODE:
		pszWork = "Invalid color space mode.";
		break;
	case kCAM_LNK_INVALID_SEND_SIZE:
		pszWork = "Invalid DPLink send size.";
		break;
	case kCAM_LNK_INVALID_BAUDRATE:
		pszWork = "Invalid DPLink Baudrate.";
		break;
	case kCAM_LNK_NO_DEVICE:
		pszWork = "DPLink device not connected.";
		break;
	case kCAM_LNK_UART_ERROR:
		pszWork = "DPLink UART error.";
		break;


	/// (ڍׂȃG?́A1000ԑ䂩X??g)
	/// JɊւڍ׃G?
	case kCAM_NO_DETAIL_ERROR:
pszWork = "No detailed error.";
		break;
	/// Detail errors relate to library initialization.
	case kCAM_API_CANNOT_CREATE_CAMERA:
pszWork = "Camera part object generation failure.";
		break;
	case kCAM_API_CANNOT_CREATE_CAMERA_BOARD:
pszWork = "Camera board object generation failure.";
		break;
	case kCAM_API_CANNOT_INITIALIZE_CAMERA_BOARD:
		pszWork = "Camera board initialization failure.";
		break;
	case kCAM_API_CANNOT_CREATE_CAMERA_PARTS:
		pszWork = "Camera part object creation failure.";
		break;
	case kCAM_API_CANNOT_ALLOCATE_LUT:
pszWork = "LUT area allocationm failure.";
		break;
	case kCAM_API_CANNOT_ALLOCATE_DMA_TRANS_BUFFER:
		pszWork = "DMA transfer buffer area allocation failure.";
		break;
	case kCAM_API_CANNOT_LOCK_DMA_TRANS_BUFFER:
		pszWork = "DMA transfer buffer area lock failure.";
		break;
	/// Detail errors relate to the recoder.
	case kCAM_API_CANNOT_ALLOCATE_CACHE:
pszWork = "The recording buffer area allocation failure.";
		break;
	/// Detail errors relate to the camera.
	case kCAM_CAMERA_DEVICE_AFE_ERROR:
		pszWork = "AFE error.";
		break;
	case kCAM_CAMERA_DEVICE_TG_ERROR:
		pszWork = "TG error.";
		break;
	case kCAM_CAMERA_DEVICE_EEPROM_ERROR:
		pszWork = "EEPROM error.";
		break;
	case kCAM_CAMERA_DEVICE_ADC_ERROR:
		pszWork = "ADC error.";
		break;
	case kCAM_CAMERA_DEVICE_DAC_ERROR:
		pszWork = "DAC error.";
		break;
	case kCAM_CAMERA_DEVICE_OTHER_ERROR:
		pszWork = "Non-specified device error.";
		break;
	/// PCI??hɊւڍ׃G?
	case kCAM_IFCARD_DEVICE_EEPROM_ERROR:
		pszWork = "EEPROM error";
		break;
	case kCAM_IFCARD_DEVICE_FLASH_ROM_ERROR:
		pszWork = "Flash ROM error.";
		break;
	case kCAM_IFCARD_DEVICE_SDRAM_ERROR:
		pszWork = "SDRAM error.";
		break;
	case kCAM_IFCARD_DEVICE_FIFO_ERROR:
		pszWork = "FIFO error.";
		break;
	case kCAM_IFCARD_DEVICE_BANK_MEMORY_ERROR:
		pszWork = "Bank memory error.";
		break;
	case kCAM_IFCARD_DEVICE_SDRAMC_ERROR:
		pszWork = "SDRAMC error.";
		break;
	case kCAM_IFCARD_DEVICE_DIP1_ERROR:
		pszWork = "DIP1 error.";
		break;
	case kCAM_IFCARD_DEVICE_DIP2_ERROR:
		pszWork = "DIP2 error.";
		break;
	case kCAM_IFCARD_DEVICE_OTHER_ERROR:
		pszWork = "Non-specified device error.";
		break;
	/// PCI??h̃RtBO?VɊւڍ׃G?
	case kCAM_IFCARD_CONFIG_SDRAMC_ERROR:
		pszWork = "SDRAMC configuration failure.";
		break;
	case kCAM_IFCARD_CONFIG_DIP1_ERROR:
		pszWork = "DIP1 configuration failure.";
		break;
	case kCAM_IFCARD_CONFIG_DIP2_ERROR:
		pszWork = "DIP2 configuration failure.";
		break;
	case kCAM_IFCARD_CONFIG_OTHER_ERROR:
		pszWork = "Non-specified FPGA configuration error.";
		break;
	case kCAM_IFCARD_DEVICE_CAMERA_ERROR:
		pszWork = "(PCI/Camera hear) configuration error.";
		break;

	/// (x́A10000ԑ䂩X??g)
	/// x
	case kCAM_CANNOT_READ_DEFAULT_LUT:
		pszWork = "Default LUT read failure.";
		break;
	case kCAM_INVALID_DEFAULT_LUT:
pszWork = "The LUT reading value is abnormal.";
		break;
	case kCAM_LV_MISSED_FRAME:
		pszWork = "A movie frame missing.";
		break;
	case kCAM_LV_INVALID_FRAME:
		pszWork = "Captured frame invalid.";
		break;
	default:
		return FALSE;
	}



		break;
	default:
		return FALSE;
	}
	strncpy_s(pszName, dwLength, pszWork, _TRUNCATE);
	assert(strlen(pszName) < MAX_NAME_LENGTH);

	return TRUE;
}

