// MyCamera.cpp : File
//

#ifndef _USE_QT_
#include "stdafx.h"
#else

#endif
#include "MyCamera.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CMyCamera::CMyCamera()
{
	m_bCreateCameraFlag = FALSE;
}

CMyCamera::~CMyCamera()
{
	if (TRUE == m_bCreateCameraFlag)
	{
		CAM_DeleteCameraEx(m_pCameraObject, TRUE);
	}
}

BOOL CMyCamera::GetCameraList(char **ppCamereList)
{
	BOOL bRlt = TRUE;

#ifdef FOR_DP21
	bRlt = CAM_Enum1394CameraEx(TRUE, 
							ppCamereList, 
							CAM_MAX_NUM_OF_CAMERA,
							CAM_MAX_NUM_OF_CAMERA_NAME);
#else
	bRlt = CAM_EnumCameraEx(TRUE, 
							ppCamereList, 
							CAM_MAX_NUM_OF_CAMERA,
							CAM_MAX_NUM_OF_CAMERA_NAME);
#endif
	return bRlt;
}

BOOL CMyCamera::CreateCamera(char *pszCameraID)
{
	BOOL bRlt = TRUE;
	m_pCameraObject = CAM_CreateCameraEx(pszCameraID, TRUE);
	if (NULL == m_pCameraObject) 
	{
		bRlt = FALSE;
	}
	else
	{
		m_bCreateCameraFlag = TRUE;
	}
	return bRlt;
}

BOOL CMyCamera::InitializeCamera()
{
	BOOL bRlt = TRUE;
	//
	// Camera object initialization
	//
	bRlt = CAM_InitCameraEx(m_pCameraObject, 
							FALSE, 
							kCAM_INITIALIZE_DEFAULT);
	return bRlt;
}

BOOL CMyCamera::StartMovie(BYTE *pbMovieImageData)
{
	BOOL bRlt = TRUE;

	bRlt = CAM_SetLastErrorEx(m_pCameraObject, 
							TRUE, 
							kCAM_NO_ERROR, 
							NULL);
	if (bRlt == FALSE) return FALSE;
	// Starts movie
	bRlt = CAM_LV_StartMovieEx(m_pCameraObject, 
							FALSE, 
							pbMovieImageData);
	if (bRlt == FALSE) return FALSE;

	return bRlt;
}

BOOL CMyCamera::StopMovie()
{
	BOOL bRlt = TRUE;
	bRlt = CAM_LV_StopMovieEx(m_pCameraObject, TRUE);
	return bRlt;
}

BOOL CMyCamera::CaptureImage(BYTE *pbSIAImageData)
{
	BOOL bRlt = TRUE;
	bRlt = CAM_SIA_CaptureEx(m_pCameraObject,
							FALSE,
							pbSIAImageData);
	return bRlt;
}

BOOL CMyCamera::GetLastError(char* szDescription)
{
	CAM_ERROR lLastError;
	CErrorLookupDP clError;
	CAM_GetLastErrorEx(m_pCameraObject, TRUE, &lLastError);
	char szName[CErrorLookupDP::MAX_NAME_LENGTH];
	BOOL bRlt = FALSE;
	if (clError.GetName(lLastError, szName, sizeof(szName)) == TRUE)
	{
		bRlt = clError.GetDescription(lLastError, 
									szDescription,
									sizeof(szName),
									CErrorLookupDP::ENGLISH);
	}
	return bRlt;
}