#ifndef DMD_H
#define DMD_H

#include <QAxWidget>
#include <QList>
#include <QByteArray>
#include <QString>
#include <QVariant>
#include <QString>

#ifdef USE_MM_TIMER
//	#include "qextserialport.h"
	#include "mmtimer.h"
#else
	#include <QTimer>
#endif

#ifdef USE_WLP_DMD
#include "wlp_interface.h"
#define USE_WLP_ADAPTER
#ifdef USE_WLP_ADAPTER
#include "..\wlp_adapter\wlp_adapter.h"
#endif
#endif

class DMD : public QObject//QAxWidget
{
	Q_OBJECT

public:
	DMD(QString id, QWidget *parent = 0);
	~DMD();

#ifdef USE_WLP_DMD
	int startDMD();
	int loadFiles(QStringList fileNames, bool ns_flip=false, bool we_flip=false);
	int trigger(int msec=0);
	int stopDMD();
#else
	int loadToMemBuffer(QString fileName);
	void unloadFromMemBuffer(int bufNum);
	int loadToDMD(int memBuf, int msec=0);
#endif	
	void clear();

#ifdef USE_MM_TIMER
	static void CALLBACK loadTimerCallBack( UINT uID,			//uTimerID
									UINT uMsg,			//dwUser : UserParam
									DWORD dwUser,		//Reserved
									DWORD dw1,			//Reserved
									DWORD dw2);			//Reserved 
#endif

#ifndef USE_MM_TIMER
private slots:
	void slotLoadTimer();
#endif

signals:
	void signalDMDCleared();

private:

#ifdef USE_WLP_DMD
#ifdef USE_WLP_ADAPTER
	WLP_Adapter m_wlpAdapter;
#else
	WLP_HDEVICE m_wlpDevice;
	ULONG m_nGray, m_nSingleFrameLen;
#endif
#endif

	QAxWidget *m_pDMD;
	QList<int> m_nListAllocMemBuf;
	int m_nClearMask;

	int clearDMD();

#ifndef USE_WLP_DMD
	int allocMemBuf();
	void deallocMemBuf(int bufNum);
#endif

	bool m_bEmitSignalCleared;
};

#endif
