#ifndef DMD_H
#define DMD_H

#include <QAxWidget>
#include <QList>
#include <QByteArray>
#include <QString>
#include <QVariant>

#ifdef USE_MM_TIMER
	#include "mmsystem.h"
	#define DEFAULT_DMD_MMTIMER_RESOLUTION	50
#else
	#include <QTimer>
#endif

class DMD : public QAxWidget
{
	Q_OBJECT

public:
	DMD(QString id, QWidget *parent = 0);
	~DMD();

	int loadToMemBuffer(QString fileName);
	void unloadFromMemBuffer(int bufNum);
	int loadToDMD(int memBuf, int msec=0);
	int clearDMD();

#ifdef USE_MM_TIMER
	static void CALLBACK loadTimerCallBack( UINT uID,			//uTimerID
									UINT uMsg,			//dwUser : UserParam
									DWORD dwUser,		//Reserved
									DWORD dw1,			//Reserved
									DWORD dw2);			//Reserved 
#endif

#ifndef USE_MM_TIMER
private slot:
	void slotLoadTimer();
#endif

private:
	QList<int> m_nListAllocMemBuf;
    QByteArray *offBytes;
    QVariant *offBuffer;

	int allocMemBuf();
	void deallocMemBuf(int bufNum);
};

#endif
