#ifndef MTIMER_H
#define MTIMER_H

#include <QObject>
#include <QTimer>
#include <windows.h>
#include "mmtimer.h"

//#define DEFAULT_MMTIMER_RESOLUTION		5


class MTimer : public QObject
{
	Q_OBJECT

public:
	MTimer(QObject *parent=0);
	~MTimer();

	int interval() const;
	bool isActive() const;
	bool isSingleShot() const;
	void setInterval(int msec);
	void setSingleShot(bool singleShot);
	int timerId() const;	
	static void singleShot(int msec, QObject *receiver, const char *member);

public slots:
	void start(int msec);
	void start();
	void stop();

signals:
	void timeout();

private:
	int m_nInterval;
	bool m_bActive;
	bool m_bSingleShot;
	UINT m_nTimerID;

	QTimer m_zeroIntervalTimer;

	static void CALLBACK mmtimerCallBack( UINT uID,			//uTimerID
								UINT uMsg,			//dwUser : UserParam
								DWORD dwUser,		//Reserved
								DWORD dw1,			//Reserved
								DWORD dw2);			//Reserved 

	static void CALLBACK mmtimerOneShotCallBack( UINT uID,			//uTimerID
								UINT uMsg,			//dwUser : UserParam
								DWORD dwUser,		//Reserved
								DWORD dw1,			//Reserved
								DWORD dw2);			//Reserved 

private slots:
	void slotTimeout();
};

#endif // MTIMER_H
