#ifndef VALVEARRAY_H
#define VALVEARRAY_H

#include <QFrame>
#include <QMouseEvent>
#include <QList>
#include <QHBoxLayout>

class Valve : public QFrame
{
    Q_OBJECT

public:
    Valve(int nPort, int nChannel);

    bool isChecked();
    void setCheck(bool check);

signals:
    void signalCheckChanged(int nPort, int nChannel, bool check);

private:
    bool m_bIsChecked;
    int m_nPort, m_nChannel;

    void mousePressEvent(QMouseEvent *event);
};

class ValveArray : public QFrame
{
    Q_OBJECT

public:
    ValveArray(int numPort, int numChannel);
    ~ValveArray();

    void setValveFixedSize(int width, int height);
    void setSpacerFixedSize(int width, int height);
    int numPort();
    int numChannel();
    bool isChecked(int nPort, int nChannel);
    void setValve(int nPort, int nChannel, bool open);

signals:
    void signalCheckChanged(int nPort, int nChannel, bool check);

private:
    QList<Valve *> m_listValve;
    QList<QSpacerItem *> m_listSpacer;
    QHBoxLayout *m_hlayoutValve;

    int m_nPort, m_nChannel;
};

#endif // VALVEARRAY_H
