#ifndef VALVECTRL_H
#define VALVECTRL_H

#include <QObject>
#include <NIDAQmx.h>
#include <windows.h>
#include "mmtimer.h"

class ValveCtrl : public QObject
{
	Q_OBJECT

public:
	ValveCtrl(QObject *parent);
	~ValveCtrl();

	void open(int port, int channel, int msec=0);
	void close(int port, int channel);
	void closeAll();

	static void CALLBACK openTimerCallBack( UINT uID,			//uTimerID
									UINT uMsg,			//dwUser : UserParam
									DWORD dwUser,		//Reserved
									DWORD dw1,			//Reserved
									DWORD dw2);			//Reserved

private:
    TaskHandle m_taskOut;
    uInt32 m_data;

    void initNIDAQmx();
	void writeNIDAQmx();
};

#endif // VALVECTRL_H
