
/** 
*
* @file
* @brief  wlp_adapter.lib main source file.
*         This is a demonstration of how to operate the DMD.
* @author longf@dspchina.com
*
*/


//lib.cpp

#include "wlp_adapter.h"

#include <math.h> 

#include <fstream>
#include <time.h>

//using  namespace  std ;

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#endif
*/


/****************/
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#undef ERROR


#include "logging.h"
#pragma comment( lib , "libglog.lib" )  

/****************/




/*
enum GrayBit
{

	GrayBit_16 =   0XFFFF , //0B 1111 1111 1111 1111  
	GrayBit_15 =   0XFFFE , //0B 1111 1111 1111 1110  
	GrayBit_14 =   0XFFFC , //0B 1111 1111 1111 1100  
	GrayBit_13 =   0XFFF8 , //0B 1111 1111 1111 1000 
	GrayBit_12 =   0XFFF0 , //0B 1111 1111 1111 0000  
	GrayBit_11 =   0XFFE0 , //0B 1111 1111 1110 0000  
	GrayBit_10 =   0XFFC0 , //0B 1111 1111 1100 0000  
	GrayBit_9  =   0XFF80 , //0B 1111 1111 1000 0000 

	GrayBit_8  =   0XFF00 , //0B 1111 1111 0000 0000
	GrayBit_7  =   0XFE00 , //0B 1111 1110 0000 0000
	GrayBit_6  =   0XFC00 , //0B 1111 1100 0000 0000
	GrayBit_5  =   0XF800 , //0B 1111 1000 0000 0000
	GrayBit_4  =   0XF000 , //0B 1111 0000 0000 0000
	GrayBit_3  =   0XE000 , //0B 1110 0000 0000 0000
	GrayBit_2  =   0XC000 , //0B 1100 0000 0000 0000
	GrayBit_1  =   0X8000 , //0B 1000 0000 0000 0000

};

*/


enum GrayBit
{

	GrayBit_16 =   0XFFFF , //0B 1111 1111 1111 1111  
	GrayBit_15 =   0XFFFE , //0B 1111 1111 1111 1110  
	GrayBit_14 =   0XFFFC , //0B 1111 1111 1111 1100  
	GrayBit_13 =   0XFFF8 , //0B 1111 1111 1111 1000 
	GrayBit_12 =   0XFFF0 , //0B 1111 1111 1111 0000  
	GrayBit_11 =   0XFFE0 , //0B 1111 1111 1110 0000  
	GrayBit_10 =   0XFFC0 , //0B 1111 1111 1100 0000  
	GrayBit_9  =   0XFF80 , //0B 1111 1111 1000 0000 


	GrayBit_8  =   0XFF , //0B 1111 1111 
	GrayBit_7  =   0XFE , //0B 1111 1110 
	GrayBit_6  =   0XFC , //0B 1111 1100 
	GrayBit_5  =   0XF8 , //0B 1111 1000 
	GrayBit_4  =   0XF0 , //0B 1111 0000 
	GrayBit_3  =   0XE0 , //0B 1110 0000 
	GrayBit_2  =   0XC0 , //0B 1100 0000 
	GrayBit_1  =   0X80 , //0B 1000 0000 

};





// 8bit image file size 
#define PER_IMAGE_SIZE_7  Length_720P*Widthth_720P   //  768K
#define PER_IMAGE_SIZE_9  Length_1080P*Widthth_1080P  // 2160K


// 1bit image file size 
#define PER_SMALL_IMAGE_SIZE_7   Length_720P*Widthth_720P/8   //  768K/8 =  96K
#define PER_SMALL_IMAGE_SIZE_9   Length_1080P*Widthth_1080P/8   // 2160K/8 = 270K


#define ONE_MEGA          1024*1024        //  1MB
#define DDR_RAM_SIZE   ONE_MEGA*1024  //  1GB


#define DOT_PER_LINE   50
#define SPACE_INTERNAL 10

#define PER_DOWN_PICS  100



#define ONE_PIC   0X18000	






/** 
*
* @brief Construct function , initialize essential variables, flags , prepare the log file
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
WLP_Adapter::WLP_Adapter(  )
{

	device = -1 ;

	m_bDevopened = FALSE ;

	m_Alldonwloadfilecount = 0 ;

	FrameActiveTime = 0 ; 
   
	RAMsize = 0 ;  

	FWdownloaded = 0 ;

	ReadyforTrigger = false ;


	//bFWBeDown = false  ;
 
	ReadCompare  = (PUCHAR)malloc( sizeof(UCHAR)*ONE_PIC*10 ) ;
	memset( ReadCompare , 0X00 ,  sizeof(UCHAR)*ONE_PIC*10  ) ;


	printf("\n\n Initialing Google Log ......   \n\n" ) ;

	google::InitGoogleLogging( "Running_log" ) ;   //just name the log file 

	google::SetLogDestination( google::INFO , ".\\RunningLog\\Running_log__" ) ;   //log file path


	printf("\n\n SDK Version: 20131016 \n\n") ;


	LOG(INFO) <<  "\n\n Program Start: \n\n "  ; 
	LOG(INFO) <<  "\n\n SDK Version: 20131016 \n\n "  ; 


}




/**  
*
* @brief DeConstruct function \n 
*
* @param NULL \n 
*
* @return NULL   \n    
*
* @note  \n
*
* @see  WlpDevInit()  \n
*        
*/
WLP_Adapter::~WLP_Adapter(  )
{

	if(device != -1)
		CloseDev( ) ;

}



/**       
*       
* @brief This function will :
*      open the device driver ; 
*      download the firmware ;
*      reopen the device ;
*	   print the firmware version; 
*      caculate the RAM size ;
*      inquire information like the DMD type ;
*      reset board and DMD .
*
* @param NULL
*
* @return Return value maybe: \n
* 	- true  
*	- false   
*
* @note  \n
*
* @see   \n
*   
*/
bool WLP_Adapter::OpenDev(  )
{


	/*
	if( m_bDevopened == TRUE )
	{

		printf("\n\n\n  The Firmware has been downloaded and Device opened OK .\n\n");

		return true ;

	}
	*/

//	printf("\n\n");
//	printf(" ***********************************************************");
	printf("\n");

	LONG ret ;


	//1. open

	/*****************/
	if ( m_bDevopened == true )
	{
		return true ;
	}
	/***************/

	bool  bFWBeDown = false  ;
	ret  = WlpDevAlloc( 0 , &device ,  bFWBeDown ) ; 
	if ( ret == WLP_SUCCESS )
	{

		if ( bFWBeDown == false )
		{

			m_bDevopened = FALSE ;

			printf("\n\n  Load RAW device success.\n\n");
	        LOG(INFO) << "\n\n  Load RAW device success.\n\n" <<endl ; 		


		}
		else
		{
			
			m_bDevopened = TRUE ; 

			printf("\n\n  Load WLP device success.\n\n");
		    LOG(INFO) << "\n\n  Load WLP device success.\n\n";		

		}

	}
	else
	{

	//	printf("\n  Load device fail.\n"); 

		return false ;

	}


	if ( bFWBeDown == false )
	{

		printf("\n  Start download Firmware :  \n");
		LOG(INFO) << "\n\n  Start download Firmware :  \n\n"; 

		PULONGLONG deviceAddr = NULL ;
		deviceAddr = (PULONGLONG)device ;

		if (  WlpDownloadFirmWare( deviceAddr  ,  0   )  )
		{

			FWdownloaded++ ;

			printf("\n  Download Firmware success.\n\n");
		    LOG(INFO) << "\n\n  Download Firmware success.\n\n";		

		}
		else
		{
			printf("\n  Download Firmware fail.\n\n" ) ;
		    LOG(INFO) << "\n\n  Download Firmware fail.\n\n" ;	

			return false ;
		}


		if (  DevReAlloc( deviceAddr ) )
		{

			printf("\n  ReLoad WLP device success.\n " )  ;
		    LOG(INFO) << "\n\n  ReLoad WLP device success.\n\n " ;	

			m_bDevopened = TRUE ; 


		}
		else
		{

			printf("\n  ReLoad WLP device fail.\n");
		    LOG(INFO) << "\n\n  ReLoad WLP device fail.\n\n" ;	

			return false ;

		}

	}

	

	/***************************************************/

	printf("\n\n");

	//Get Firmware version 
	Wlp_GetFWversion(  ); 


	//Get FPGA version 
	ULONG FpgaVer = 0 ;
	ret = WlpDevInquire( device , WLP_DEV_VERSION, &FpgaVer ) ;
	if (ret == WLP_SUCCESS)
	{
		printf("\n  Get FPGA version:  %x \n " , FpgaVer );
	    LOG(INFO) << "\n\n  Get FPGA version: " <<  FpgaVer << "\n\n" ;	

	}
	else
	{

		printf("\n  Get FPGA version fail.\n");
 		LOG(INFO) << "\n\n  Get FPGA version fail.\n" ;	

		goto FAIL ;

		return false ;

	}

	ret = WlpDevInquire( device , WLP_DEV_DMD_TYPE , &DevInit.dmdtype  );
	if (ret == WLP_SUCCESS)
	{
		//printf("\n  Get DMD type  :  ");
	}
	else
	{
		printf("\n\n  Get DMD type fail.\n");
	    LOG(INFO) << "\n\n  Get DMD type fail.\n" <<endl ; 		

		goto FAIL ;

		return  false ;

	}


	switch( DevInit.dmdtype  )
	{

	case WLP_DMDTYPE_XGA_055A:	
		DMDtype = WLP_DMDTYPE_XGA_055A ;
		printf("\n  Get DMD type : .55 \n " );
	    LOG(INFO) << "\n\n  Get DMD type : .55 \n\n" <<endl ; 		
		break;

	case WLP_DMDTYPE_XGA_07A:	
		DMDtype = WLP_DMDTYPE_XGA_07A ;
		printf("\n  Get DMD type : .7 \n " );
	    LOG(INFO) << "\n\n  Get DMD type : .7 \n\n" <<endl ; 		
		break;

	case WLP_DMDTYPE_1080P_095A:	
		DMDtype = WLP_DMDTYPE_1080P_095A ;
		printf("\n  Get DMD type : .95 \n " );
	    LOG(INFO) << "\n\n  Get DMD type : .95 \n\n " <<endl ; 		
		break;

	default:
		printf("\n Warning! Can't get DMD type, please check if it attached to the board. \n " );
	    LOG(INFO) << "\n\n Warning! Can't get DMD type, please check if it attached to the board. \n\n " <<endl ; 				
		break ;

	}


	/**********/
	if ( !Read_DDR_SPD( )   )
	{
		return false ;
	}
	/**********
	RAMsize = 1024*1024*1024 ;
	printf("\n  Define RAM size : %3d GB \n " ,DDR_RAM_SIZE/(1048576*1024) );
	/**********/


	//Step 2.reset device
	printf("\n  Reset device \n");
	

	ULONG	param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_RESET, &param2) ;
	if (ret == WLP_SUCCESS)
	{
		printf("\n		 ----- success.\n");
		LOG(INFO) << "\n\n  Reset device ----- success. \n\n" <<endl ; 	
	}
	else
	{
		printf("\n		 ----- fail.\n");
		LOG(INFO) << "\n\n  Reset device ----- fail . \n\n" <<endl ; 	
		return false;
	}


	//wait for reseting device to finish.
	Sleep(100);


	//Step 3.reset dmd
	printf("\n  Reset dmd \n");
	param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_DMD_RESET, &param2) ;
	if (ret == WLP_SUCCESS)
	{
			
		FrameActiveTime = param2 ;

		printf("\n		 ----- success.\n");
		LOG(INFO) << "\n\n  Reset dmd ----- success . \n\n" <<endl ; 	
	}
	else
	{
		printf("\n		 ----- fail.\n");
		LOG(INFO) << "\n\n  Reset dmd ----- fail . \n\n" <<endl ; 	
		return false;
	}


	//wait for reseting dmd to finish.
	Sleep(100);


	//Step 4. Read Frame Active time
	param2 = 0;
	ret =  WlpDevControl(device, WLP_DEV_GET_FRAME_MARGIN , &param2 ) ;
	if (ret == WLP_SUCCESS)
	{
		FrameActiveTime = param2 ;

	}
	else
	{

		return  false ;
	}


	printf(" \n  *****************************************");

	//
	return  true ;


FAIL:
	WlpDevFree(device);
	return  false ;

}






/**
*
* @brief change the flag when the device is removed \n
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*    
*/
void WLP_Adapter::DevRemoved( ) 
{

	m_bDevopened = false ;

	printf("\n\n  Device unattached ! \n\n\n");
	LOG(INFO) << "\n\n  Device unattached ! \n\n\n" <<endl ; 	

}



/**  
*
* @brief Release all the resource allocated for the device. \n
*
* @param NULL  \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*       
*/
void WLP_Adapter::CloseDev(  )
{

	WLP_HDEVICE t = device ;

	device = -1 ;

	WlpDevFree( t ) ;

}




/** 
 *
* @brief  Download frequency setting ,trigger setting to the device . 
 *	This is the substitution of the WlpDevInit() function due to the frequent setting method's changing. 
 * 
 * @param hDevice pointer to an WLP device handle variable 
 * @param pDevInit the construction object contains the information of the frequency \n
 *   setting ,trigger setting \n
 *
 * @return Return value maybe: \n
 *  - WLP_ERR_HDEVICE 
 *  - WLP_ERR_GRAY 
 *  - WLP_SUCCESS
 *  - WLP_ERR
 *
 * @note  \n
 *
 * @see  WlpDevInit()  \n
 *
 */
LONG  WLP_Adapter::WlpDevInit2( WLP_HDEVICE hDevice, PDEVINIT2 pDevInit )
{

	if (pDevInit == NULL)
		return WLP_ERR_HDEVICE;

	//set gray
	if ( WlpDevControl( hDevice , WLP_DEV_GRAY , &pDevInit->gray ) != WLP_SUCCESS )
	{

		printf("\n\n\n Set gray ERROR! \n");

		return WLP_ERR_GRAY;

	}

	// set freq


	ULONG ret = WlpDevControl(hDevice , WLP_DEV_FRAME_MARGIN , &pDevInit->frame_margin );
	if (ret != WLP_SUCCESS)
	{

		printf("\n\n\n Set OLD Active Time ERROR ! \n");

		return ret ;

	}

	ret = WlpDevControl(hDevice , WLP_DEV_FRAME_INTERVAL , &pDevInit->frame_interval );
	if (ret != WLP_SUCCESS)
	{

		printf("\n\n\n Set OLD Blank Time ERROR ! \n");

		return ret ;

	}




	if( !Wlp_DevNewFrequencySet( pDevInit->gray ,  
							     pDevInit->frame_margin  ,
							     pDevInit->frame_interval  ) )
	{

		printf("\n\n\n Set New Frequency ERROR ! \n");
			
		return WLP_ERR ;

	}



	//set trigger
	ret = WlpDevControl(hDevice, WLP_DEV_TRIGGER_SETTING, &pDevInit->trigger_setting) ;
	if (ret != WLP_SUCCESS)
	{

		printf("\n\n\n Set trigger mode ERROR ! \n");

		return ret ;

	}


	// all init success
	return WLP_SUCCESS ;

}



/**
*
* @brief Open file 
*
* @param foldName : the folder path that contain the images 
*
* @return  NULL \n
*
* @note The download images number is limited by the DMD's RAM size , just now our board's DDR size is 1G.
*       For the .7 format , the max number is 1397 ( 1024^3 /(1024*768 ) )
*       For the .9 format , the max number is  485 ( 1024^3 /(2048*1080) )
*
* @see  \n
* 
*/
void WLP_Adapter::FileOpen( char *foldName   )
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");
		LOG(INFO) << "\n\n\n Please open the device first . \n" <<endl ; 	

		return ;

	}

	printf("\n\n\n Select images to download: \n");
	printf("\n  Note: The download images number is limited by the DMD's RAM size ! \n");
	m_filenames.clear( );
	m_filenames.resize(0);

	GetFiles( foldName , m_filenames ) ; 

	UINT num = (UINT)m_filenames.size( ) ;
	printf("\n  You have selected %d files \n " , num );
	LOG(INFO) << "\n\n  You have selected " << num <<  " files \n\n"; 	


	// sort the file
	std::sort( m_filenames.begin( ) , m_filenames.end( ) , less_equal<string>() ) ;

	return ;

}



/**
*
* @brief Open file 
*
* @param foldName : the folder path that contain the images 
*
* @return  NULL \n
*
* @note The download images number is limited by the DMD's RAM size , just now our board's DDR size is 1G.
*       For the .7 format , the max number is 1397 ( 1024^3 /(1024*768 ) )
*       For the .9 format , the max number is  485 ( 1024^3 /(2048*1080) )
*
* @see  \n
*
*/
void WLP_Adapter::FileOpen2( std::vector<string>& flist  )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");
		LOG(INFO) << "\n\n\n Please open the device first . \n" <<endl ; 	

		return ;

	}

	printf("\n\n\n Select images to download: \n");
	printf("\n  Note: The download images number is limited by the DMD's RAM size ! \n");


	m_filenames = flist ;

	UINT num = (UINT)m_filenames.size( ) ;

	printf("\n  You have selected %d files \n " , num );
	LOG(INFO) << "\n\n  You have selected " << num <<  " files \n\n"; 	

	// sort the file
//	std::sort( m_filenames.begin( ) , m_filenames.end( ) , less_equal<string>() ) ;

	return ;

}





/**
*
* @brief GetFileExt 
*
* @param fn : the images file name   
*
* @return  NULL \n
*
* @note if have ext name return char* point to '.'
*       if no ext name, point to last char
*       if fn is invalid, point to NULL.
*
* @see  \n
* 
*/
char* GetFileExt(char* fn)  
{

	if( fn && strlen(fn) <1)
		return NULL;

	char * p = fn + strlen( fn );
	int i;
	for ( i = 0; *p != ('\\') && *p != ('/') && p >= fn; p--,i++ )
		if(*p == '.')
			return p;

	if ( *p == ('\\') || *p == ('/') || p==fn)
		p = fn + strlen( fn );

	return p;

}



/**
*
* @brief GetFilePath 
* @param path : the images file path  
*
* @return  NULL \n
*
* @note if have Path seperator character  return char* point to '/' or '\' 
*       if no Path seperator character, point to last char of path
*       if path is invalid, point to NULL.
*
* @see  \n
* 
*/
char* GetFilePath(char* path) 
{

	if( path && strlen(path) <1)
		return NULL;

	char * p = path + strlen( path );
	int i;

	for ( i = 0;  p >= path; p--,i++ )
		if(*p == ('\\')  || *p == ('/') )
			return p;

	if (  p==path)
		p = path + strlen( path );

	return p;

}


/**
*
* @brief it will get all the image files' name ,and store in the flist 
*
* @param foldName : the folder path
* @param flist : to contain the the image file path  
*
* @return  NULL \n
*
* @note if have Path seperator character  return char* point to '/' or '\' 
*       if no Path seperator character, point to last char of path
*       if path is invalid, point to NULL.
*
* @see  \n
* 
*/
void  WLP_Adapter::GetFiles( char *foldName, std::vector<string>& flist )  
{  

	HANDLE file;  
	WIN32_FIND_DATAA fileData;  
	char line[1024];  
	char * p = GetFilePath(foldName);
	string path;string temp;

	if(p)
	{
		memset(line,0,1024);
		strncpy( line ,foldName , p-foldName ) ;
		path = line;
		path +="\\";
	}

	char fn[1000];  
	flist.clear();
	//mbstowcs(fn,(const char*)foldName,999);  
	memcpy( fn,(const char*)foldName ,999  );
	file = FindFirstFileA(fn, &fileData);  
	FindNextFileA(file, &fileData);  
	while(FindNextFileA(file, &fileData))
	{  

		//memo: I want to locate a file filter here, abandon the no-image file ,
		// but Mr.Shang told me that the image convert function maybe also unsuccessful, 
		// so ,it is improper
		memset(line,0,1024);
		memcpy( line,(const wchar_t*)fileData.cFileName,259 ) ;
		temp = path;
		temp += line;
		flist.push_back(temp);

	}  

	return ;  
}  



/**
*
* @brief abandoned
*
* @param foldName : the folder path
* @param flist : to contain the the image file path     
*
* @return  NULL \n
*
* @note \n
*
* @see  \n
* 
*/
void  WLP_Adapter::get_filelist( char *foldName, std::vector<string>& filelist )  
{  

	HANDLE file;
	WIN32_FIND_DATAW fileData;
	char line[1024];
	wchar_t fn[1000];

	mbstowcs( fn ,(const char*)foldName ,999 ) ;

	filelist.clear();

	file = FindFirstFileW(fn, &fileData);
	FindNextFileW(file, &fileData);

	while( FindNextFileW(file, &fileData) )
	{
		wcstombs(line,(const wchar_t*)fileData.cFileName,259 );

		filelist.push_back( line );

	}

	return ; 

}  





/**
*
* @brief  set the input and output trigger mode 
*
* @param trigeMode : the input trigger method  
* @param trigeSync : the output trigger method  
*
* @return 
*    WLP_ERR
*    WLP_SUCCESS
*
* @note : this function is majority set the input trigger method , in order to set these two trigger
*   method in the TrigerSetALL().
*
* @see  SetTrigerMode2( )   TrigerSetALL( )  
*
*/
LONG WLP_Adapter::SetTrigerMode1( int trigeMode ,int trigeSync )
{
	// TODO: Add your control notification handler code here

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");
		LOG(INFO) << "\n\n\n Please open the device first . \n "; 	

		return WLP_ERR ;
	}


	switch( trigeMode )
	{

	case WLP_TRIGGER_SINGLE_FRAME :
		printf("\n Input Trigger set:  SINGLE_FRAME \n"  );
		LOG(INFO) << "\n Input Trigger set:  SINGLE_FRAME \n "; 	
		break;

	case WLP_TRIGGER_FRAMES :
		printf("\n Input Trigger set:  FRAME \n"  );
		LOG(INFO) << "\n Input Trigger set:  FRAME \n "; 	
		break;

	case WLP_TRIGGER_FRAMES_AND_AUTOSTOP :
		printf("\n Input Trigger set:  FRAME and AUTOSTOP \n"  );
		LOG(INFO) << "\n Input Trigger set:  FRAME and AUTOSTOP \n "; 	
		break;

	case WLP_TRIGGER_LOOP :
		printf("\n Input Trigger set:  LOOP \n"  );
		LOG(INFO) << "\n Input Trigger set:  LOOP \n "; 	
		break;

	}


	/********************************/
	//Patch the FPGA bug .
	memset( &ThisTrigger , 0X00 , sizeof( SophistcateTrigger ) ) ;
	ThisTrigger.TrigeModeX    = trigeMode ;

	if ( trigeMode == WLP_TRIGGER_SINGLE_FRAME )
	{

		ThisTrigger.m_FrameMarginForMode1    =  DevInit.frame_margin ;
		ThisTrigger.m_FrameIntervalForMode1  =  DevInit.frame_interval ;

	//	printf(" ThisTrigger.m_FrameMarginForMode1   =  %d us ." , ThisTrigger.m_FrameMarginForMode1  );
	//	printf(" ThisTrigger.m_FrameIntervalForMode1 =  %d us ." , ThisTrigger.m_FrameIntervalForMode1  );
			 
	}

	TriggerQueue.push_back( ThisTrigger ) ;

	/********************************/

	int temp_trigger_setting = 0 ;
	temp_trigger_setting = TrigerSetALL(  trigeMode , trigeSync ); 

	//set trigger
	int ret = 0 ;
	ret = WlpDevControl(device , WLP_DEV_TRIGGER_SETTING, &temp_trigger_setting);
	return ret ; 

}





/**
*
* @brief set the input and output trigger mode 
*
* @param trigeMode : the input trigger method  
* @param trigeSync : the output trigger method  
*
* @return 
*      WLP_ERR 
*      WLP_SUCCESS
*
* @see     SetTrigerMode1()   TrigerSetALL() 
*
* @note : this function is majority set the output trigger method , in order to set these two triger
*   method in the TrigerSetALL().
*
*/
LONG WLP_Adapter::SetTrigerMode2( int trigeMode ,int trigeSync )
{

	// TODO: Add your control notification handler code here

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}

	switch( trigeSync )
	{

	case WLP_SYNC_ALL_FRAMES :
		printf("\n Output Trigger set  ALL_FRAMES  \n"  );
		LOG(INFO) << "\n Output Trigger set  ALL_FRAMES  \n "; 	
		break;

	case WLP_SYNC_SINGLE_FRAME :
		printf("\n Output Trigger set  SINGLE_FRAME \n"  );
		LOG(INFO) << "\n Output Trigger set  SINGLE_FRAME \n "; 	
		break;

	default:
		break ;

	}


	int temp_trigger_setting = 0 ;
	temp_trigger_setting = TrigerSetALL(  trigeMode , trigeSync ); 

	//set trigger
	int ret = 0 ;
	ret = WlpDevControl(device , WLP_DEV_TRIGGER_SETTING, &temp_trigger_setting);
	return ret ; 

}





/**
*
* @brief  TrigerSetALL  forge both input and output trigger mode in order to set to the board
*
* @param trigeMode : the input trigger method  
* @param trigeSync : the output trigger method  
*
* @return temp_trigger_setting
*
* @note  \n
*
* @see     SetTrigerMode1()   SetTrigerMode2() 
*
*/

ULONG WLP_Adapter::TrigerSetALL(   int trigeMode , int trigeSync   )
{

	int temp_trigger_setting = 0 ;

	temp_trigger_setting = (INT) ( (INT)1 | trigeMode |trigeSync );

	return temp_trigger_setting ;

}


 

/** 
*
* @brief  give the board a input trigger signal 
*
* @param NULL \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::Trigger()
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}

	if ( ReadyforTrigger != true  )
	{

		printf( " \n\n\n Please download images firstly ! \n\n\n " ) ;

		return WLP_ERR ;

	}


	/****************************************/
	// Patch for FGPA bug . 

//	printf( " \n\n^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n " ) ;

	UINT param2 = 1;
	int ret  = 0 ;

//	printf( " \n\n  Enumerate all the mode :  \n " ) ;

	int size = TriggerQueue.size();

	/*
	for ( int i = 0 ; i<size ; i++ )
	{
		printf(" Cell  %d   mode :   %d    \n "  , i , TriggerQueue[i].TrigeModeX    ); 
	}
	*/

	// Define Be triggered WLP_TRIGGER_SINGLE_FRAME to a new mode--- WLP_TRIGGER_MODE_5

	// Only one mode in the queue, and it is mode1, and it is pending (not triggered ), 
	// need to trigger twice .
	// And then change it to the WLP_TRIGGER_MODE_5 mode 
	if (   TriggerQueue.size() == 1 )
	{

		if(   ( TriggerQueue[0].TrigeModeX == WLP_TRIGGER_SINGLE_FRAME )
	      ) 
		{

			ret =  WlpDevControl( device , WLP_DEV_TRIGGER_SINGLE , &param2 ) ;
			if ( ret == WLP_SUCCESS )
			{
				printf("  TriSingle 1 ; ");
				LOG(INFO) << "TriSingle  1  ; "; 	
			}
			else
			{
				printf(" \nTriger Single 1 fail.\n ");
				LOG(INFO) << "\nTriger Single 1 fail.\n "; 	

			}

			ULONG tempSleep = 0 ;
			// us -> ms
			tempSleep = ( ThisTrigger.m_FrameMarginForMode1  + ThisTrigger.m_FrameIntervalForMode1 ) / 1000  ;
			Sleep( tempSleep + 1 ) ; 
	 		printf(" Slept for %d ms ." , tempSleep +1  );

			ret =  WlpDevControl(device, WLP_DEV_TRIGGER_SINGLE, &param2 ) ;
			if (ret == WLP_SUCCESS)
			{
				printf("  TriSingle 2 ; \n");
				LOG(INFO) << "TriSingle 2 ;\n "; 	
			}
			else
			{
				printf(" \nTriger Single 2 fail.\n ");
				LOG(INFO) << "\nTriger Single 2 fail.\n "; 	
			}

			TriggerQueue[0].TrigeModeX = WLP_TRIGGER_MODE_5 ;

			return ret ;	

		}


		if (  ( TriggerQueue[0].TrigeModeX != WLP_TRIGGER_SINGLE_FRAME )
			) 
		{

			ret =  WlpDevControl( device , WLP_DEV_TRIGGER_SINGLE , &param2 ) ;
			if ( ret == WLP_SUCCESS )
			{
				printf("  TriSingle ; \n");
				LOG(INFO) << "TriSingle ; \n" ; 	
			}
			else
			{
				printf(" \nTriger Single fail.\n ");
				LOG(INFO) << "\nTriger Single fail.\n "; 	
			}


			return ret ;

		}



	}



	int QueueSize = 0 ;
	QueueSize = TriggerQueue.size() ;
	bool TriggerTwice = false ;
	int Other3Mode = 0 ;

	//ǰģʽ1ô͵øǰлģʽж
	if (   ( TriggerQueue.size() >= 2 )
		)
	{


		// һģʽ1 
		if (   TriggerQueue[ QueueSize -1 ].TrigeModeX != WLP_TRIGGER_SINGLE_FRAME  )
		{

		//	printf( " һģʽ1 ģʽ1ģʽ5    "  ) ;

			// other situation, only need trigger one time .
			ret =  WlpDevControl( device , WLP_DEV_TRIGGER_SINGLE , &param2 ) ;
			if ( ret == WLP_SUCCESS )
			{
				printf("  TriSingle ; \n");
				LOG(INFO) << "TriSingle ; \n" ; 	
			}
			else
			{
				printf(" \nTriger Single fail.\n ");
				LOG(INFO) << "\nTriger Single fail.\n "; 	
			}

			return ret ;

		}
		else// һģʽ1 
		{

			// Ӻǰңֱҵһ ģʽ1  ¼λ
			for ( int i = QueueSize -1 ; i>= 0 ; i-- )
			{

				//
				if ( TriggerQueue[ i ].TrigeModeX == WLP_TRIGGER_SINGLE_FRAME )
				{
					continue ;
				}

				// 1 ҵtriggerģʽ1  һ
				if ( TriggerQueue[ i ].TrigeModeX == WLP_TRIGGER_MODE_5 )
				{

			//		printf( " ҵtriggerģʽ1  һ  i = %d " , i ) ;

					// other situation, only need trigger one time .
					ret =  WlpDevControl( device , WLP_DEV_TRIGGER_SINGLE , &param2 ) ;
					if ( ret == WLP_SUCCESS )
					{
						printf("  TriSingle ; \n");
						LOG(INFO) << "TriSingle ; \n" ; 	
					}
					else
					{
						printf(" \nTriger Single fail.\n ");
						LOG(INFO) << "\nTriger Single fail.\n "; 	
					}

					TriggerQueue[ QueueSize -1 ].TrigeModeX  = WLP_TRIGGER_MODE_5 ;

					return ret ;

				}
				//2  ǰ津ģʽ
				else if (  ( TriggerQueue[ i ].TrigeModeX != WLP_TRIGGER_MODE_5 ) 
					  &&( TriggerQueue[ i ].TrigeModeX != WLP_TRIGGER_SINGLE_FRAME )  )
				{


			//		printf( " ǰ津ģʽ  i = %d " , i ) ;

					ret =  WlpDevControl( device , WLP_DEV_TRIGGER_SINGLE , &param2 ) ;
					if ( ret == WLP_SUCCESS )
					{
						printf("  TriSingle 1 ; ");
						LOG(INFO) << "TriSingle  1  ; "; 	
					}
					else
					{
						printf(" \nTriger Single 1 fail.\n ");
						LOG(INFO) << "\nTriger Single 1 fail.\n "; 	

					}



					ULONG tempSleep = 0 ;
					// us -> ms
					tempSleep = (  ThisTrigger.m_FrameMarginForMode1  +  ThisTrigger.m_FrameIntervalForMode1 ) / 1000  ;
					Sleep( tempSleep + 1 ) ; 
		 			printf(" Slept for %d ms ." , tempSleep +1  );

					ret =  WlpDevControl(device, WLP_DEV_TRIGGER_SINGLE, &param2 ) ;
					if (ret == WLP_SUCCESS)
					{
						printf("  TriSingle 2 ; \n");
						LOG(INFO) << "TriSingle 2 ; \n"; 	
					}
					else
					{
						printf(" \nTriger Single 2 fail.\n ");
						LOG(INFO) << "\nTriger Single 2 fail.\n "; 	
					}

					// trigger ,¼
					TriggerQueue[ QueueSize -1 ].TrigeModeX = WLP_TRIGGER_MODE_5 ;

					return ret ;	

				}


			}// Ӻǰңֱҵһ ģʽ1  ¼λ


			//3 ȫģʽ1
			//else
			{

		//		printf( "  3 ȫģʽ1 "   ) ;

				ret =  WlpDevControl( device , WLP_DEV_TRIGGER_SINGLE , &param2 ) ;
				if ( ret == WLP_SUCCESS )
				{
					printf("  TriSingle 1 ; ");
					LOG(INFO) << "TriSingle  1  ; "; 	
				}
				else
				{
					printf(" \nTriger Single 1 fail.\n ");
					LOG(INFO) << "\nTriger Single 1 fail.\n "; 	
				}

				ULONG tempSleep = 0 ;
				// us -> ms
				tempSleep = (  ThisTrigger.m_FrameMarginForMode1  +  ThisTrigger.m_FrameIntervalForMode1 ) / 1000  ;
				Sleep( tempSleep + 1 ) ; 
				printf(" Slept for %d ms ." , tempSleep +1  );

				ret =  WlpDevControl(device, WLP_DEV_TRIGGER_SINGLE, &param2 ) ;
				if (ret == WLP_SUCCESS)
				{
					printf("  TriSingle 2 ; \n");
					LOG(INFO) << "TriSingle 2 ; \n"; 	
				}
				else
				{
					printf(" \nTriger Single 2 fail.\n ");
					LOG(INFO) << "\nTriger Single 2 fail.\n "; 	
				}

				// trigger ,¼
				TriggerQueue[ QueueSize -1 ].TrigeModeX = WLP_TRIGGER_MODE_5 ;

				return ret ;		 

			}


		}// һģʽ1 

	}
	
	return ret ;


}




/** 
*
* @brief  Read the device's register directly
*
* @param NULL \n
*
* @return NULL \n
*
* @note  for debug conveniently \n
*
* @see   \n
*   
**/
void WLP_Adapter::Wlp_DevRReg(  )
{

	ULONG RegValue = 0  ;

	WlpDevRReg( device , 0x00000001, &RegValue ) ;

}





/** 
*
* @brief to download both the parameters and the image files to the board
*
* @param frame_rate :  the images' roll speed
* @param gray : the images' gray depth  
* @param trigeMode : the input trigger method  
* @param trigeSync : the output trigger method  
*
* @return  TRUE FALSE \n
*
* @note  \n
*
* @see  InitDev( )   DownloadFile( )  \n
*   
**/
bool  WLP_Adapter::InitANDDownload(     UINT m_FrameMargin , 
									    UINT m_FrameInterval ,
										UINT gray ,
										int trigeMode , 
										int trigeSync   ) 
{


	if ( m_bDevopened == FALSE )
	{
		printf( "\n  Please open the device first . \n " ) ;

		return false ;

	}


	if ( RAMsize == 0  )
	{

		//	printf( " \n\n  Can't find Memory Chips, define RAM size : %d GB \n " , (DDR_RAM_SIZE/1048576)/1024  ) ;
		printf( " \n\n  Can't find Memory on the board, wouldn't download image ! \n "  ) ;
		LOG(INFO) <<  " \n\n  Can't find Memory on the board, wouldn't download image ! \n "  ;

		return false ;

	}


	/********************************/
	//Patch the FPGA bug .
	memset( &ThisTrigger , 0X00 , sizeof( SophistcateTrigger ) ) ;
	ThisTrigger.TrigeModeX    = trigeMode ;
	//ThisTrigger.IfBeTriggered = false ;
	ThisTrigger.m_FrameMarginForMode1   = m_FrameMargin   ;
	ThisTrigger.m_FrameIntervalForMode1 = m_FrameInterval ;

	//printf(" ThisTrigger.m_FrameMarginForMode1   =  %d us ." , ThisTrigger.m_FrameMarginForMode1  );
	//printf(" ThisTrigger.m_FrameIntervalForMode1 =  %d us ." , ThisTrigger.m_FrameIntervalForMode1  );

	TriggerQueue.push_back( ThisTrigger ) ;

	/********************************/

	bool bInitDev = FALSE ;
	bInitDev = InitDev( m_FrameMargin , m_FrameInterval , gray , trigeMode , trigeSync ) ; 
	if ( bInitDev == false )
	{

		printf( "\n  Initialize Device Fail .\n " ) ;
		LOG(INFO) << "\n  Initialize Device Fail .\n "; 	

		return false ;
	
	}
	/********************************/

	if ( DownloadFile( ) == false )
	{

		return false ;

	}


	ReadyforTrigger = true ;

	return true ;

}







/** 
*
* @brief to download the setting parameters to the board
*
* @param frame_rate :  the images' roll speed
* @param gray : the images' gray depth  
* @param trigeMode : the input trigger method  
* @param trigeSync : the output trigger method 
*
* @return TRUE FALSE \n
*
* @note  \n
*
* @see   InitANDDownload( )  DownloadFile( )   \n
*   
**/
bool WLP_Adapter::InitDev(   UINT m_FrameMargin , 
						     UINT m_FrameInterval ,  
						     UINT gray ,
						     int trigeMode , 
							 int trigeSync   ) 

{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return FALSE ;
	}


	printf("\n\n\n\n Let's Start \n");
	LOG(INFO) << "\n\n\n\n Let's Start \n\n"; 	

	UINT filesize =  (UINT)m_filenames.size( ) ;
	if ( m_filenames.size() <= 0 )
	{

		printf("\n  Are you kidding? You havn't seleceted image files. \n");
		LOG(INFO) << "\n  Are you kidding? You havn't seleceted image files. \n"; 	

		return FALSE ;
	}

	int ret;


	//Step 4.init device
	printf("\n\n  Init device \n") ;
	LOG(INFO) << "\n\n  Init device \n\n"; 	

	if ( DevInit.dmdtype == 0XFF )
	{

		printf("\n  There is NO DMD , it will does not continue ! \n");
		LOG(INFO) << "\n  There is NO DMD , it will does not continue ! \n"; 	

	//	return false ;

	}


	// Set the DMD type combo box in the dialog GUI
	switch( DevInit.dmdtype )
	{

	case WLP_DMDTYPE_XGA_055A:
		m_BitFrameSize = Length_720P*Widthth_720P/8;		
		break;

	case WLP_DMDTYPE_XGA_07A:
		m_BitFrameSize = Length_720P*Widthth_720P/8;    
		break;

	case WLP_DMDTYPE_1080P_095A:
		//m_BitFrameSize = 1920*1080/8;    
		m_BitFrameSize = Length_1080P*Widthth_1080P/8;    
		break;

	default:
		break;

	}

	printf("\n  BitFrameSize is 0D%d Bytes = 0X%X Bytes =  %5.2f KB =  %5.2f MB \n"  ,m_BitFrameSize, m_BitFrameSize  , (float)((float)m_BitFrameSize /(ULONG)1024) , (float)((float)m_BitFrameSize /(ULONG)1048576) );
	LOG(INFO) << "\n\n   BitFrameSize is " << m_BitFrameSize << "\n\n" ; 

	/********************************************************************/	
	DevInit.gray = gray ;
	printf("\n  Gray : %X \n"  , DevInit.gray );
	LOG(INFO) << "\n\n  Gray :  " << DevInit.gray << "\n\n" ; 

	DevInit.frame_margin = m_FrameMargin ; 
	printf("\n  Frame Margin : %d \n"  , m_FrameMargin );
	LOG(INFO) << "\n\n  Frame Margin : " << m_FrameMargin << "\n\n" ;  

	/********************************************************************/

	DevInit.frame_interval = m_FrameInterval ; 
	printf("\n  Frame Interval : %d \n"  , m_FrameInterval ) ;
	LOG(INFO) << "\n\n  Frame Interval :" << m_FrameInterval   << "\n\n" ; 

	/********************************************************************/

	switch( trigeMode )
	{

	case WLP_TRIGGER_SINGLE_FRAME:
		printf("\n  Input Trigger set:  SINGLE_FRAME \n"  );
		LOG(INFO) << "\n\n  Input Trigger set:  SINGLE_FRAME \n\n"  ; 
		break;

	case WLP_TRIGGER_FRAMES:
		printf("\n  Input Trigger set:  FRAME \n"  );
		LOG(INFO) << "\n\n  Input Trigger set:  FRAME \n\n"  ; 
		break;

	case WLP_TRIGGER_FRAMES_AND_AUTOSTOP:
		printf("\n  Input Trigger set:  FRAME and AUTOSTOP \n"  );
		LOG(INFO) << "\n\n  Input Trigger set:  FRAME and AUTOSTOP \n\n"  ; 
		break;

	case WLP_TRIGGER_LOOP:
		printf("\n  Input Trigger set:  LOOP \n"  );
		LOG(INFO) << "\n\n  Input Trigger set:  LOOP \n\n"  ; 
		break;

	}


	switch( trigeSync )
	{
	case WLP_SYNC_ALL_FRAMES:
		printf("\n  Output Trigger set  Enable \n"  );
		LOG(INFO) << "\n\n   Output Trigger set  Enable \n\n"  ; 
		break;

	case WLP_SYNC_SINGLE_FRAME :
		printf("\n  Output Trigger set  Enable \n"  );
		LOG(INFO) << "\n\n   Output Trigger set  Enable \n\n"  ; 
		break;

	}

	DevInit.trigger_setting = TrigerSetALL( trigeMode , trigeSync ) ;

	ret = this->WlpDevInit2( device , &DevInit ) ;
	if ( ret == WLP_SUCCESS )
	{

		printf("\n              ------- Init success.\n\n ");
		LOG(INFO) << "\n\n               ------- Init success.\n\n "  ; 

		return true ;

	}
	else
	{

		printf("\n               ------- Init fail.\n\n ");
		LOG(INFO) << "\n\n              ------- Init fail.\n\n  "  ; 

		return false ;

	}

	return true ;

}





/** 
*
* @brief to download image to the board
*
* @param NULL \n
*
* @return bool type value \n
*
* @note  \n
*
* @see   InitANDDownload( )  InitDev( )   \n
*   
**/
bool WLP_Adapter::DownloadFile( void )
{

	//Step 6.calc DownLoadLen  
	printf("\n\n\n  Calculating for downloading images :  \n");
	LOG(INFO) << "\n\n\n  Calculating for downloading images :  \n\n"  ; 
	
	ULONG SingleFrameLen = m_BitFrameSize * DevInit.gray ;

	//For 1080p , treat it specially
	ULONG SingleFrameLen_1080p_EXTEND = ( Length_1080P_EXTEND *Widthth_1080P / 8 ) * DevInit.gray ;

	// Set the image size
	int width  = 0 ;
	int height = 0 ; 

	switch( DevInit.dmdtype )
	{

	case WLP_DMDTYPE_XGA_055A:
		width  = Length_720P ;
		height =  Widthth_720P ;
		break;

	case WLP_DMDTYPE_XGA_07A:
		width  = Length_720P ;
		height =  Widthth_720P ;
		break;

	case WLP_DMDTYPE_1080P_095A:
		//width  = 1920 ;
		width  = Length_1080P ;
		height = Widthth_1080P ;
		break;

	default:
		break;

	}
	printf("\n  Width: %d ; Height: %d \n" , width ,height );
	LOG(INFO) << "\n\n  Width :" << width << " Height: "  << height << "\n\n"  ; 

	// set bitmask  
	ULONG bitmask = 0 ;

	if ( DevInit.gray == 1 )
	{
		bitmask = GrayBit_1;
	}
	else if (  DevInit.gray == 2 )
	{
		bitmask = GrayBit_2;
	}
	else if (  DevInit.gray == 3 )
	{
		bitmask = GrayBit_3;
	}
	else if (  DevInit.gray == 4 )
	{
		bitmask = GrayBit_4;
	}
	else if (  DevInit.gray == 5 )
	{
		bitmask = GrayBit_5;
	}
	else if (  DevInit.gray == 6 )
	{
		bitmask = GrayBit_6;
	}
	else if (  DevInit.gray == 7 )
	{
		bitmask = GrayBit_7;
	}
	else if (  DevInit.gray == 8 )
	{
		bitmask = GrayBit_8;
	}
	else if (  DevInit.gray == 9 )
	{
		bitmask = GrayBit_9;
	}
	else if (  DevInit.gray == 10 )
	{
		bitmask = GrayBit_10;
	}
	else if (  DevInit.gray == 11 )
	{
		bitmask = GrayBit_11;
	}
	else if (  DevInit.gray == 12 )
	{
		bitmask = GrayBit_12;
	}
	else if (  DevInit.gray == 13 )
	{
		bitmask = GrayBit_13;
	}
	else if (  DevInit.gray == 14 )
	{
		bitmask = GrayBit_14;
	}
	else if (  DevInit.gray == 15 )
	{
		bitmask = GrayBit_15;
	}
	else if (  DevInit.gray == 16 )
	{
		bitmask = GrayBit_16;
	}

	printf( "\n  Bitmask: %X \n" , bitmask );
	LOG(INFO) << "\n\n  Bitmask: " << bitmask << "\n\n"  ; 


	/***********************************************************************/
	// The black image prelude .  Add on 2013.09.25 

	printf("\n   _____________________________________ \n");

	printf( "\n   Firstly, The black image prelude .  Add on 2013.09.25  \n"   );
	LOG(INFO) << "\n\n\n Firstly, The black image prelude .  Add on 2013.09.25 \n\n"  ; 


	// malloc memory for the image data to be download
	//ULONG LargeImageBuffSize = SingleFrameLen * 1  ;
	if ( DMDtype == WLP_DMDTYPE_1080P_095A )
	{
		SingleFrameLen = SingleFrameLen_1080p_EXTEND ;
	}
	pLargeImageBuff = (PUCHAR)malloc( sizeof(BYTE)*SingleFrameLen );
	if ( pLargeImageBuff == NULL )
	{
		printf( "\n\n\n  *** Can't alloc memory for The black image prelude !!! *** \n\n\n"   );
		LOG(INFO) << "\n\n\n  *** Can't alloc memory !!! *** \n\n\n"  ; 

		return FALSE ;
	}

	memset( pLargeImageBuff , 0x00 , sizeof(BYTE)*SingleFrameLen ) ;

	ULONG ret1 = 0 ;
	//ret = SingleDownload( StartAddr, SingleDownSize , DownloadTimes ,ConvertFileCount ,SingleFrameLen ) ;
	ret1 = SingleDownload( 0 , SingleFrameLen , 0 , 0 , SingleFrameLen ) ;
	if ( ret1 != WLP_SUCCESS )
	{
		printf(" \n\n               ------- The black image prelude fail ! \n  ");  
		LOG(INFO) << " \n\n  The black image prelude fail ! \n\n  "  ;  

		return false ;
	}
	else
	{
		printf(" \n\n               ------- The black image prelude OK !  \n  ");  
		LOG(INFO) << " \n\n  The black image prelude OK ! \n\n "  ;  
	}

	// free the black prelude :
	free( pLargeImageBuff ) ;

	/***********************************************************************/
	printf( "\n\n\n  OK , Let's download the real images:  \n"   );

	// malloc memory for the image data to be download
	ULONG LargeImageBuffSize = SingleFrameLen * PER_DOWN_PICS  ;
	pLargeImageBuff = (PUCHAR)malloc( sizeof(BYTE)*LargeImageBuffSize );
	if ( pLargeImageBuff == NULL )
	{
		printf( "\n\n\n  *** Can't alloc memory !!! *** \n\n\n"   );
	    LOG(INFO) << "\n\n\n  *** Can't alloc memory !!! *** \n\n\n"  ; 

		return FALSE ;
	}


	float MByte = (float)LargeImageBuffSize/(ULONG)1048576 ;

	printf("\n\n  You determine to download %5d pictures one time. \n\n" , PER_DOWN_PICS );
	LOG(INFO) << "\n\n  You determine to download " <<PER_DOWN_PICS<< " pictures one time. \n\n"  ; 

	printf("  Alloc Memory for download : %10.5f M  \n" , MByte );
	memset( pLargeImageBuff , 0X00 , sizeof(UCHAR)*LargeImageBuffSize  ) ;

	//count all has download file 
	m_Alldonwloadfilecount = 0 ;

	// convert image file to the format that proper for downloading 
	printf("\n  Convert image file to the format that proper for downloading \n "  );
	LOG(INFO) << "\n  Convert image file to the format that proper for downloading \n" ;

	UINT TotalConvertFileCount = 0 ;
	UINT ConvertFileCountOneTime = 0 ; 
	UINT DownloadTimes = 0 ;

	// Add on 2013.09.25
	// Because of The black image prelude, the start address retreat for one SingleFrameLen  . 
	ULONG ThisTimeStartAddr = 0  + SingleFrameLen ;   
	
	ULONG FileNum = ( ULONG )m_filenames.size(  )  ;
	char * ConvertRet = NULL ;
	ULONG ret = 0 ;

	// restore the SingleFrameLen , for the 1080p , the converting processing DON"T need extend the size : 
	SingleFrameLen = m_BitFrameSize * DevInit.gray ;

	// malloc memory for the image data to be converted
	PUCHAR pSinlgeImageBuff = ( PUCHAR )malloc( SingleFrameLen ) ;  //one frame
	if ( !pSinlgeImageBuff )
	{

		printf( "\n\n\n  *** Can't alloc memory !!! *** \n\n\n"   ) ;
	    LOG(INFO) << "\n\n\n  *** Can't alloc memory !!! *** \n\n\n"  ; 

		return false ;
	}
	memset( pSinlgeImageBuff , 0x00 , sizeof(UCHAR)*SingleFrameLen  ) ;

	int  i = 0 ;

	while ( (FileNum-1) >=  (i)  )
	{

		string m_filename = m_filenames[i];

		i++ ;

		// when return NULL , the file folder may contain file that is no image, 
		// or , the GetGrayBinFormat() operates fail 
		ConvertRet = GetGrayBinFormat(  m_filename.c_str(),
										width,
										height, 
										bitmask , 
									    ( PCHAR )pSinlgeImageBuff ) ;

		if ( ConvertRet == NULL )
		{
			printf( " error! "   ) ;

			continue ;		
		}



		/**********************************************************************************/

		// the file folder may contain file that is not image, so ,just count the image file.
		ConvertFileCountOneTime ++ ; 

		/**********************************************************************************/
		// modified on 2013.11.07 , Edging for the .95DMD of 64 pixels .
		if ( DMDtype == WLP_DMDTYPE_1080P_095A )
		{
			for ( int i=0 ; i< Widthth_1080P * DevInit.gray  ; i++  )
			{
				memcpy( pLargeImageBuff + ( ConvertFileCountOneTime-1 )*Length_1080P_EXTEND*Widthth_1080P +  i*Length_1080P_EXTEND/8 + 8 , 
					    pSinlgeImageBuff + i*Length_1080P/8 , 
						sizeof(UCHAR)*Length_1080P/8 ) ;
			}
		
		}
		else
		{

			memcpy( pLargeImageBuff + ( ConvertFileCountOneTime-1 )* SingleFrameLen  , 
				    pSinlgeImageBuff   , 
				    sizeof(UCHAR)*SingleFrameLen ) ;
		}
	
		/**********************************************************************************/
		if ( ( ConvertFileCountOneTime -1) % DOT_PER_LINE == 0 )
		{
			printf(" \n  %5d  " ,(ConvertFileCountOneTime-1) / DOT_PER_LINE + 1 );
		}

		printf(".");

		if ( ( ConvertFileCountOneTime ) % SPACE_INTERNAL == 0 ) 
		{

			printf("  ");

		}


		if ( DMDtype == WLP_DMDTYPE_1080P_095A )
		{
			SingleFrameLen = SingleFrameLen_1080p_EXTEND ;
		}

		// ﵽPER_DOWN_PICS أ вͼƬСPER_DOWN_PICSں洦
		if (  PER_DOWN_PICS  ==  ConvertFileCountOneTime )
		{

			ULONG SingleDownSize = SingleFrameLen * PER_DOWN_PICS ;

			//if no picture has been converted.
			if ( 0 == ConvertFileCountOneTime )
			{
				printf("\n\n\n *** No file Converted properly , Download will stop ! *** \n\n\n ");
	            LOG(INFO) << "\n\n\n *** No file Converted properly , Download will stop ! *** \n\n\n "  ; 
				
				return  FALSE ;
			}

			ret = SingleDownload( ThisTimeStartAddr , SingleDownSize , DownloadTimes ,ConvertFileCountOneTime ,SingleFrameLen ) ;
			if ( ret != WLP_SUCCESS )
			{
				printf(" Download fail ! ");  
	            LOG(INFO) << " Download fail !  "  ;  

				goto EndDown ;

			}

			ThisTimeStartAddr = ThisTimeStartAddr + SingleDownSize ;

			TotalConvertFileCount = TotalConvertFileCount + ConvertFileCountOneTime ;
			ConvertFileCountOneTime = 0 ;

			DownloadTimes++ ; 

			memset( pLargeImageBuff , 0X00 , sizeof(UCHAR)*SingleDownSize  ) ;

		}


	} // while ( (FileNum-1) >=  (i)  )


	if ( DMDtype == WLP_DMDTYPE_1080P_095A )
	{
		SingleFrameLen = SingleFrameLen_1080p_EXTEND ;
	}

	// ġСPER_DOWN_PICSģǲͼƬ,ͼƬԱPER_DOWN_PICSǲҪִе
	ULONG SingleDownSize = SingleFrameLen * ConvertFileCountOneTime ;
	if ( SingleDownSize != 0 )
	{
		ret = SingleDownload( ThisTimeStartAddr , 
			                  SingleDownSize , 
							  DownloadTimes ,
							  ConvertFileCountOneTime , 
							  SingleFrameLen ) ;
		if ( ret != WLP_SUCCESS )
		{
			goto EndDown ;
		}

	}

	free( pSinlgeImageBuff );
	pSinlgeImageBuff = NULL ;
	free( pLargeImageBuff );
	pLargeImageBuff = NULL ;

	return true ;

EndDown:
	free( pSinlgeImageBuff );
	pSinlgeImageBuff = NULL ;
	free( pLargeImageBuff );
	pLargeImageBuff = NULL ;

	return false ;   //13.09.11 

}



/** 
*
* @brief Devides the images downloading into several times , each time calls this function 
*
* @param ThisTimeStartAddr :  this time where will start at in the DDR RAM 
* @param SingleDownSize : this time download size
* @param DownloadTimes : how many times have download
* @param ConvertFileCount : how many images have been downloaded 
* @param SingleFrameLen : the size of the images  
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   DownloadFile() \n
*   
**/
ULONG WLP_Adapter::SingleDownload( ULONG ThisTimeStartAddr ,   
								   ULONG SingleDownSize , 
							       ULONG DownloadTimes ,
								   ULONG ThisTimeConvertFileCount ,
								   ULONG SingleFrameLen )
{

	printf("\n ");

	ULONG ret ;


	/****************************************************************************/
	//Step 5.Set download addr

	if ( ThisTimeStartAddr + SingleDownSize >= RAMsize )
	{

		printf("\n  Warming : the image data to download is exceed the DDR RAM size , the download size will be truncated \n");

		printf("\n   Download for the %4d time, and the last time .\n" , DownloadTimes +1  ) ;



		//Step 7. download frame data to DMD
		printf("\n       Downloading:  \n"  );
	    LOG(INFO) << "\n       Downloading:  \n"  ; 

		ULONG temp = RAMsize - ThisTimeStartAddr ;
		float RemainSizeMB = (float)( (temp)/1048576 ) ;
		printf("\n       The remain RAM size %5f MB , which is only available for about %4d pictures, \n" , RemainSizeMB , ( RAMsize - ThisTimeStartAddr)/SingleFrameLen  );

		printf("\n       Download Start at %5f MB  \n" ,(float)ThisTimeStartAddr/1048576  );
		printf("\n       ``````````````  \n"  );

		ret = WlpDevLoadFrame( device , pLargeImageBuff , ThisTimeStartAddr , RAMsize - ThisTimeStartAddr ) ;
		if ( ret == WLP_SUCCESS )
		{
			printf("\n       Load frames success.\n");
			LOG(INFO) << "\n       Load frames success.\n"  ; 

			m_Alldonwloadfilecount = m_Alldonwloadfilecount +  (RAMsize - ThisTimeStartAddr)/SingleFrameLen ;
			printf("\n       Have download %6d pictures\n " , m_Alldonwloadfilecount ) ;

			printf("\n   _____________________________________\n");
		}
		else
		{

			printf("\n       Load frames fail.\n");
			LOG(INFO) << "\n       Load frames fail.\n"  ; 

			return WLP_ERR ;

		}

		return WLP_RAM_FULL ;

	}


	/****************************************************************************/
	printf("\n   Download for the %4d time. \n" , DownloadTimes +1  ) ;


	//Step 7. download frame data to DMD
	printf("\n       Downloading:  \n"  );
	printf("\n       This time will download %4d pictures, the size is %5f MB \n" , ThisTimeConvertFileCount, (float)SingleDownSize/1048576  );

	printf("\n       Download Start at %5f MB  \n" ,(float)ThisTimeStartAddr/1048576  );
	printf("\n       ``````````````  \n"  );

	ret = WlpDevLoadFrame( device , pLargeImageBuff , ThisTimeStartAddr ,SingleDownSize ) ;
	if ( ret == WLP_SUCCESS )
	{

		printf("\n       Download frames success: \n");
		LOG(INFO) << "\n       Load frames success.\n"  ; 

		m_Alldonwloadfilecount = m_Alldonwloadfilecount + ThisTimeConvertFileCount ;
		printf("         Have download %6d pictures\n" , m_Alldonwloadfilecount );

		ULONG xsize = (ULONG)( RAMsize - ThisTimeStartAddr - SingleDownSize );
		printf("         The RAM remains %6f MB\n " , (float)xsize/1048576  );
		printf("\n   _____________________________________\n");

	}
	else
	{

		printf("\n       Load frames fail.\n");
		LOG(INFO) << "\n       Load frames fail.\n"  ; 

	}

	return ret ;

}




/** 
*
* @brief start the DMD 
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see  Stop() \n
*   
**/
void WLP_Adapter::Start()
{


	ULONG param2 = 0;
	ULONG ret = 0;


	/***************************************************************************************/
	// For USB3.0 problem trail
	// Set DMD start Addr
	printf("\n   Set DMD display start Addr at: "  );


	param2 = 0 ;
	ret =  WlpDevControl(device, WLP_DEV_DISPLAY_START_SET , &param2) ;
	if (ret == WLP_SUCCESS)
	{
		printf("\n	                          %d MB \n" , param2 );
		LOG(INFO) << "\n\n   Set DMD display start Addr at:" << param2 << "\n\n "  ; 

	}
	else
	{
		printf("\n                          Set FAIL! "  );
		LOG(INFO) << "\n                          Set FAIL! "   ; 

	}


	/***************************************************************************************/
	printf("\n   Set DMD display length: "  );

	//param2 = m_Alldonwloadfilecount * m_BitFrameSize * DevInit.gray   ;

	
	printf("\n\n               -------  include the black image prelude ! "  );

	// For The black image prelude .  Add on 2013.09.25 
	if ( DMDtype == WLP_DMDTYPE_1080P_095A )
	{
		m_BitFrameSize = Length_1080P_EXTEND*Widthth_1080P /8 ;
	}

 	param2 = ( m_Alldonwloadfilecount + 1 )* m_BitFrameSize * DevInit.gray   ; 

	ret =  WlpDevControl(device, WLP_DEV_DISPLAY_LENGTH_SET , &param2 ) ;
	if (ret == WLP_SUCCESS )
	{
		printf("\n	                    %10d B = %6f MB \n" , param2 ,(float)param2/1048576 );
		LOG(INFO)<< "\n\n   Set DMD display length: "  << param2   << "\n\n "  ; 

	}
	else
	{
		printf("\n                          Set FAIL! "  );
		LOG(INFO) << "\n                          Set FAIL!  "  ; 

	}



	/***************************************************************************************/
	//Step 9.start dmd
	printf("\n   Start dmd \n\n"  );


	//ֱ01param2ʲôֵҪ
	ret =  WlpDevControl( device , WLP_DEV_DMD_START , &param2 ) ;
	if (ret == WLP_SUCCESS)
	{
		printf("               ------- Start dmd success.\n\n\n");
		LOG(INFO) << "\n\n               ------- Start dmd success.\n\n\n"  ; 
	}
	else
	{
		printf("               ------- Start dmd fail.\n\n\n");
		LOG(INFO) << "\n\n               ------- Start dmd fail.\n\n\n"  ; 
		return ;

	}

	//wait for starting dmd to finish.
	Sleep(100);

	/***************************************************************************************/

	printf(" Please 'trigger' to roll the picturs....\n\n\n\n\n") ;


}




/** 
*
* @brief Stop the DMD 
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see  Start( ) \n
*   
**/
void WLP_Adapter::Stop()
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return ;
	}


	UINT param2 = 0;
	int ret =  WlpDevControl(device, WLP_DEV_DMD_STOP, &param2) ;
	if (ret == WLP_SUCCESS)
	{

		ReadyforTrigger = false ;

		printf("\n\n Stop DMD success.\n\n\n");
		LOG(INFO) << "\n\n Stop DMD success.\n\n\n"  ; 

	}
	else
	{

		printf("\n\n Stop DMD fail.\n\n\n");
		LOG(INFO) << "\n\n Stop DMD fail.\n\n\n"  ; 

	}


	/********************************/
	//Patch the FPGA bug .

	TriggerQueue.clear( ) ;

	/********************************/

}


/** 
*
* @brief Reverse the right and left of the images 
*
* @param bNS_FLIP change flag \n
*
* @return  WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   CompData( ) \n
*   
**/
LONG WLP_Adapter::NsFlip( BOOL bNS_FLIP )
{

	printf("\n");

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}



	int ret =  WlpDevControl( device , WLP_DEV_NS_FLIP , &bNS_FLIP ) ;
	if( ret == WLP_SUCCESS )
	{
		printf("set NS_FLIP.\n");
		LOG(INFO) << "set NS_FLIP.\n"  ; 

	}
	else
	{
		printf("set NS_FLIP fail.\n");
		LOG(INFO) << "set NS_FLIP fail .\n"  ; 

	}


	LONG StatusRegValue;
	ret = WlpDevInquire( device, WLP_DEV_STATUS_ALLBITS , &StatusRegValue );
	if (ret == WLP_SUCCESS)
	{
		printf("get NS_FLIP success.\n");
		LOG(INFO) << "get NS_FLIP.\n"  ; 
	}
	else
	{
		printf("get NS_FLIP fail.\n");
		LOG(INFO) << "get NS_FLIP fail .\n"  ; 

		return WLP_ERR ;
	}


	printf(  ("%8X \n "),   StatusRegValue);

	return ret ;

}




/** 
*
* @brief Convert the black and white to each other...
*
* @param bNS_COMP_DATA change flag  \n
*
* @return WLP_ERR WLP_SUCCESS  \n
*
* @note  \n
*
* @see  NsFlip( ) \n
*   
**/
LONG WLP_Adapter::CompData( BOOL bNS_COMP_DATA )
{

	printf("\n");

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}


	int ret =  WlpDevControl( device , WLP_DEV_COMP_DATA , &bNS_COMP_DATA ) ;
	if( ret == WLP_SUCCESS )
	{
		printf("set Compare Data .\n");
		LOG(INFO) << "set Compare Data .\n"  ; 
	}
	else
	{
		printf("set Compare Data fail.\n");
		LOG(INFO) << "set Compare Data fail.\n"  ; 
	}


	LONG StatusRegValue;
	ret = WlpDevInquire( device , WLP_DEV_STATUS_ALLBITS , &StatusRegValue );
	if (ret == WLP_SUCCESS)
	{
		printf("get Compare Data success.\n");
		LOG(INFO) << "get Compare Data success.\n"  ; 
	}
	else
	{
		printf("get Compare Data fail.\n");
		LOG(INFO) << "get Compare Data fail.\n"  ; 

		return WLP_ERR ;
	}

	printf(  ("%8X \n "),   StatusRegValue );

	return ret ;


}


/** 
*
* @brief  Change the PWM's duty cycle
*
* @param PWMDutyCycle :  PWM's duty cycle to set \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::SetPWMDutyCycle( UINT PWMDutyCycle )
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}


	printf("set PWM Duty Cycle to %d.\n" , PWMDutyCycle );

	int ret =  WlpDevControl( device , WLP_DEV_PWM_DUTY_CYCYLE , &PWMDutyCycle ) ;
	if( ret == WLP_SUCCESS )
	{

		printf("set OK.\n"  );

	}
	else
	{

		printf("set fail.\n");

	}

	return ret ;

}


/** 
*
* @brief  Get the PWM's duty cycle in the FPGA
*
* @param GetPWMDutyCycle :  Get PWM's duty cycle in the FPGA \n
*
* @return  WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::GetPWMDutyCycle( PUINT PWMDutyCycle )
{



	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}



	int ret =  WlpDevControl( device , WLP_DEV_FPGA_GET_PWM_DUTY_CYCYLE , PWMDutyCycle ) ;
	if( ret == WLP_SUCCESS )
	{

		printf("  Get PWM Duty Cycle  %d.\n" , *PWMDutyCycle );

	}
	else
	{

		printf("  Get fail.\n");

	}

	return ret ;

}



/** 
*
* @brief Turn ON or OFF the LED 
*
* @param LedCtrlData :   1 or 0 \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::LEDCtrl( UINT LedCtrlData )
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}

	int ret =  WlpDevControl( device , WLP_DEV_LED_CTRL , &LedCtrlData ) ;
	if( ret == WLP_SUCCESS )
	{
		printf(" \n Set LED OK .\n");
	}
	else
	{
		printf(" \n Set LED fail.\n");
	}

	return ret ;

}



/** 
*
* @brief Set the GPIO status
*
* @param GPIO_SetValue : Data to write  \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::GPIO_Set( UINT GPIO_SetValue )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}



	int ret =  WlpDevSetGPIO( device , &GPIO_SetValue ) ;
	if( ret == WLP_SUCCESS )
	{

		printf("  Set GPIO OK .\n");

	}
	else
	{

		printf("  Set GPIO fail.\n");

	}

	return ret ;

}



/** 
*
* @brief  Get the GPIO status
*
* @param GPIO_GetValue : Data to read  \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::GPIO_Get( PUINT GPIO_GetValue )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}



	int ret =  WlpDevGetGPIO( device ,  &GPIO_GetValue ) ;
	if( ret == WLP_SUCCESS )
	{

		printf("  Get GPIO OK .\n");

	}
	else
	{

		printf("  Get GPIO fail.\n");

	}

	return ret ;

}





#define TEST 1



/** 
*
* @brief  I2C bus write
*
* @param WData : Data to write \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::I2CWriteData( PULONG WData )
{

	int ret ;

	ret =  WlpDevControl( device , WLP_DEV_I2C_WRITEDATA , WData ) ;
	if( ret == WLP_SUCCESS )
	{
		// printf("  \n I2C write OK .\n");
	}
	else if( ret == WLP_I2C_BUSY ) 
	{
		printf("  \n\n I2C Bus busy . \n");
	}
	else if( ret == WLP_I2C_FAIL )
	{
		printf("  \n\n I2C operate failed.  Perhaps i2c chip does not exist or the chip address is not right. \n\n " ) ;
	}

	return ret ;

}



/** 
*
* @brief Download parameter for controlling the I2C bus before Write or Read
*
* @param I2COper : structure contains the necessary parameters  \n
*
* @return WLP_ERR WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::I2CCtrl( I2C_OPER I2COper )
{

	int ret ;

	ULONG Ctrl = I2COper.W_or_R          +
		         I2COper.NumOfBytes * 256  +  
		         I2COper.RegAddr    * 256 * 256 +  
		         I2COper.DevAddr    * 256 * 256 * 256  ;


	ret =  WlpDevControl( device , WLP_DEV_I2C_CTRL , &Ctrl ) ;
	if( ret == WLP_SUCCESS )
	{
	//	printf(" \n I2C write OK .\n");

		return true ; 
	}
	else if( ret == WLP_I2C_BUSY ) 
	{
		printf("  \n\n I2C Bus busy . \n");

		return false ; 
	}
	else if( ret == WLP_I2C_FAIL )
	{
		printf("  \n\n I2C operate failed.  Perhaps i2c chip does not exist or the chip address is not right. \n\n " ) ;
	
		return false ; 
	}

	return true ; 

}



/** 
*
* @brief I2C read
*
* @param RData  :  contains the gets Data.     \n
*
* @return WLP_ERR  WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
LONG WLP_Adapter::I2CReadData( PULONG RData )
{
	int ret ;

	ret =  WlpDevControl( device , WLP_DEV_I2C_READDATA ,  RData ) ;
	if( ret == WLP_SUCCESS )
	{
		// printf("  \n I2C write OK .\n");
	}
	else if( ret == WLP_I2C_BUSY ) 
	{
		printf("  \n\n I2C Bus busy . \n");
	}
	else if( ret == WLP_I2C_FAIL )
	{
		printf("  \n\n I2C operate failed.  Perhaps i2c chip does not exist or the chip address is not right. \n\n " ) ;
	}

	return ret ;

}




#define I2C_W  0X0     
#define I2C_R  0X1     

//shang 
//#define I2C_DEV_ADDR_PWM_W  0X50    //0B 0101 0000
//#define I2C_DEV_ADDR_PWM_R  0X51    //0B 0101 0001

//for faro beta board, change to 0x58
#define I2C_DEV_ADDR_PWM_W  0X58    //0B 0101 0000
#define I2C_DEV_ADDR_PWM_R  0X59    //0B 0101 0001



/** 
*
* @brief Set the PWM through I2C
*
* @param PWMData  :  PWM value.  \n
*
* @return WLP_ERR  WLP_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
bool WLP_Adapter::I2CPWM_SetDutyCycle( UINT PWMData )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return false ;
	}


	ULONG setdata = 0 ;

	setdata = PWMData ;

	I2C_OPER I2CPWMOper;
	memset( &I2CPWMOper, 0 , sizeof(I2C_OPER ) );

	I2CPWMOper.W_or_R     =  I2C_W ;
	I2CPWMOper.NumOfBytes =  0 ;
	I2CPWMOper.RegAddr    =  PWMData  ;
	I2CPWMOper.DevAddr    =  I2C_DEV_ADDR_PWM_W ;
	*PULONG(I2CPWMOper.W_Data) =  (ULONG)PWMData ;

	//I2CWriteData( I2CPWMOper ) ; 
	if ( 	I2CCtrl( I2CPWMOper )   )
	{
		return true ;
	}
	else
	{
		return false ;
	}



}



/** 
*
* @brief Get the PWM value through I2C
*
* @param NULL \n
*
* @return PWM Data \n
*
* @note  \n
*
* @see   \n
*   
**/
UCHAR WLP_Adapter::I2CPWM_GetDutyCycle(  )
{



	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;

	}



	//	ULONG Getdata = 0 ;
	UINT PWMData  = 0  ; 

	I2C_OPER I2CPWMOper;
	memset( &I2CPWMOper, 0 , sizeof(I2C_OPER ) );

	I2CPWMOper.W_or_R     =  I2C_R ;
	I2CPWMOper.NumOfBytes =  0X0 ;
	I2CPWMOper.RegAddr    =  0X0 ;
	I2CPWMOper.DevAddr    =  I2C_DEV_ADDR_PWM_R ;

	*PULONG(I2CPWMOper.R_Data)  =  0 ;

	I2CCtrl( I2CPWMOper ) ;
	I2CReadData( PULONG(I2CPWMOper.R_Data) ) ; 

	PWMData = *(PUINT)I2CPWMOper.R_Data ;

	printf( " \n\n  Get PWM data : 0X%X  \n " , PWMData  ) ;

	return PWMData ;

}





#define I2C_DEV_ADDR_LED_W  0X82    //0B 1000 0010
#define I2C_DEV_ADDR_LED_R  0X83    //0B 1000 0011


#define PCA9536_OUTPUT_PORT    0X01   //0x01 Output Port
#define PCA9536_Configuration  0X03   //0x03 Configuration



/** 
*
* @brief  Get the PWM value through I2C
*
* @param LEDData :  LED intensity value.   \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void WLP_Adapter::I2CLED_Set( UINT LEDData )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return  ;
	}



	/****************************************************/
	I2C_OPER I2CLEDOperConfig ;
	memset( &I2CLEDOperConfig, 0 , sizeof(I2C_OPER ) );

	I2CLEDOperConfig.W_or_R     =  I2C_W ;
	I2CLEDOperConfig.NumOfBytes =  1 ;
	I2CLEDOperConfig.RegAddr    =  PCA9536_Configuration  ;   //0x03 Configuration
	I2CLEDOperConfig.DevAddr    =  I2C_DEV_ADDR_LED_W ;
	*PULONG(I2CLEDOperConfig.W_Data) = (ULONG)0 ;

	I2CWriteData( PULONG(I2CLEDOperConfig.W_Data) ) ; 
	I2CCtrl( I2CLEDOperConfig ) ;

	/****************************************************/

	I2C_OPER I2CLEDOper ;
	memset( &I2CLEDOper, 0 , sizeof(I2C_OPER ) );

	I2CLEDOper.W_or_R     =  I2C_W ;
	I2CLEDOper.NumOfBytes =  1 ;
	I2CLEDOper.RegAddr    =  PCA9536_OUTPUT_PORT  ;   //0x01 Output Port
	I2CLEDOper.DevAddr    =  I2C_DEV_ADDR_LED_W ;
	*PULONG(I2CLEDOper.W_Data) = (ULONG)LEDData ;

	I2CWriteData( PULONG(I2CLEDOper.W_Data) ) ; 
	I2CCtrl( I2CLEDOper ) ;


}


/** 
*
* @brief  Get the LED intensity value through I2C
*
* @param NULL \n
*
* @return  LED intensity value \n
*
* @note  \n
*
* @see   \n
*   
**/
UCHAR WLP_Adapter::I2CLED_Get(  )
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}


	UINT LEDData = 0  ;
	I2C_OPER I2CLEDOper ;
	memset( &I2CLEDOper, 0 , sizeof(I2C_OPER ) );

	I2CLEDOper.W_or_R     =  I2C_R ;
	I2CLEDOper.NumOfBytes =  1 ;
	I2CLEDOper.RegAddr    =  PCA9536_OUTPUT_PORT  ;   //0x01 Output Port
	I2CLEDOper.DevAddr    =  I2C_DEV_ADDR_LED_R ;

	I2CCtrl( I2CLEDOper ) ;
	I2CReadData( (PULONG)I2CLEDOper.R_Data ) ; 

	LEDData = *(PUINT)I2CLEDOper.R_Data ;

	printf( " \n\n  Get LED data: 0X%X  " , LEDData  ) ;

	return LEDData ;



}






//L3GD20
//MEMS motion sensor:
//three-axis digital output gyroscope


//The Slave ADdress (SAD) associated with the L3GD20 is 110101xb
//if the SDO pin is connected to ground, the LSb value is 0 (address 1101010b).
#define I2C_DEV_ADDR_3AxisGyro_W  0XD4    //0B 110101 0 0
#define I2C_DEV_ADDR_3AxisGyro_R  0XD5    //0B 110101 0 1
     

//Table 11. SAD+read/write patterns  defined , ??? (outstanding) ???
#define I2C_DEV_ADDR_3AxisGyro_W2  0XD0     
#define I2C_DEV_ADDR_3AxisGyro_R2  0XD1       


/** 
*
* @brief read from the three-axis digital output gyroscope  
*
* @param RegAddr  :  address.  
* @param numBytes :  data count in byte .  
*
* @return read data \n
*
* @note  \n
*
* @see   \n
*   
**/
ULONG WLP_Adapter::Gyroscope_Read( UCHAR RegAddr , UINT numBytes )
{

	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}



	//	ULONG Getdata = 0 ;
	UCHAR ReadData  = 0  ; 

	I2C_OPER L3GD20 ;
	memset( &L3GD20 , 0 , sizeof(I2C_OPER ) );

	L3GD20.W_or_R     =  I2C_R ;
	L3GD20.NumOfBytes =  numBytes ;
	L3GD20.RegAddr    =  RegAddr ;
	L3GD20.DevAddr    =  I2C_DEV_ADDR_3AxisGyro_R  ;//R2

	*PULONG( L3GD20.R_Data )  =  0 ;

	I2CCtrl( L3GD20 ) ;
	I2CReadData( PULONG( L3GD20.R_Data) ) ; 

	ReadData = *(PUCHAR)L3GD20.R_Data ;

	printf( " \n\n  Get 3-axis digital output gyroscope data : 0X%X  at 0X%X  \n " , ReadData , RegAddr ) ;

	return ReadData ;



}






//LIS3DH
//MEMS digital output motion sensor
//ultra low-power high performance 3-axes nano accelerometer

#define I2C_DEV_ADDR_3AxesNanoAccel_W  0X30   //0B 0011 0000
#define I2C_DEV_ADDR_3AxesNanoAccel_R  0X31   //0B 0011 0001


/** 
*
* @brief set the 3-axes 'nano' accelerometer  
*
* @param RegAddr  :  address.  
* @param Data :  parameter to write .  
*
* @return True \n
*
* @note  \n
*
* @see   \n
*   
**/
ULONG WLP_Adapter::LIS3DH_WriteReg( UCHAR RegAddr , UCHAR Data )
{

	I2C_OPER LIS3DH;
	memset( &LIS3DH , 0 , sizeof(I2C_OPER ) );

	LIS3DH.W_or_R     =  I2C_W ;
	LIS3DH.NumOfBytes =  1 ;
	LIS3DH.RegAddr    =  RegAddr ;
	LIS3DH.DevAddr    =  I2C_DEV_ADDR_3AxesNanoAccel_W  ;

	*PULONG( LIS3DH.R_Data )  =  Data ;

	I2CCtrl( LIS3DH ) ;

	//return Data ;
	return 1 ;

}



/** 
*
* @brief read the 3-axes 'nano' accelerometer  
*
* @param RegAddr  :  address. 
* @param Data :  to contain the data read .   
*
* @return True \n
*
* @note  \n
*
* @see   \n
*   
**/
ULONG WLP_Adapter::LIS3DH_ReadReg( UCHAR RegAddr , UCHAR* Data )
{

	//ULONG Getdata = 0 ;
	ULONG ReadData  = 0  ; 

	I2C_OPER LIS3DH;
	memset( &LIS3DH , 0 , sizeof(I2C_OPER ) );

	LIS3DH.W_or_R     =  I2C_R ;
	LIS3DH.NumOfBytes =  1 ;
	LIS3DH.RegAddr    =  RegAddr ;
	LIS3DH.DevAddr    =  I2C_DEV_ADDR_3AxesNanoAccel_R  ;

	*PULONG( LIS3DH.R_Data )  =  0 ;

	I2CCtrl( LIS3DH ) ;
	I2CReadData( PULONG( LIS3DH.R_Data ) ) ; 

	*Data = *(PUCHAR)LIS3DH.R_Data ;

//	printf( " \n\n  Get 3-axesnanoaccelerometer data : 0X%X  at 0X%X  \n " , ReadData , RegAddr ) ;

	//return ReadData ;
	return 1 ;

}


/** 
*
* @brief Get 3-axes'nano'accelerometer ID 
*
* @param val :  to contain the data read .   \n
*
* @return Status [value of FSS] \n
*
* @note  \n
*
* @see   \n
*   
**/
status_t WLP_Adapter::LIS3DH_GetWHO_AM_I(u8_t* val)
{

	if( !LIS3DH_ReadReg(LIS3DH_WHO_AM_I, val) )
	{
		return MEMS_ERROR;
	}

	printf( " \n\n  Get 3-axes'nano' accelerometer ID : 0X%X  at 0X%X  \n " , *val , 0XF ) ;

	return MEMS_SUCCESS ;

}


/** 
*
* @brief Sets LIS3DH Output Data Rate
*
* @param Output Data Rate \n
*
* @return Status [MEMS_ERROR, MEMS_SUCCESS] \n
*
* @note  \n
*
* @see   \n
*   
**/
status_t WLP_Adapter::LIS3DH_SetODR(LIS3DH_ODR_t ov )
{

	u8_t value;

	if( !LIS3DH_ReadReg(LIS3DH_CTRL_REG1, &value) )
		return MEMS_ERROR;

	value &= 0x0f;
	value |= ov<<LIS3DH_ODR_BIT;

	if( !LIS3DH_WriteReg(LIS3DH_CTRL_REG1, value) )
		return MEMS_ERROR;

	return MEMS_SUCCESS;

}


/** 
*
* @brief Sets LIS3DH Operating Mode
*
* @param Modality (LIS3DH_NORMAL, LIS3DH_LOW_POWER, LIS3DH_POWER_DOWN) \n
*
* @return Status [MEMS_ERROR, MEMS_SUCCESS] \n
*
* @note  \n
*
* @see   \n
*   
**/
status_t WLP_Adapter::LIS3DH_SetMode(LIS3DH_Mode_t md) 
{

	u8_t value;
	u8_t value2;
	static   u8_t ODR_old_value;

	if( !LIS3DH_ReadReg(LIS3DH_CTRL_REG1, &value) )
		return MEMS_ERROR;

	if( !LIS3DH_ReadReg(LIS3DH_CTRL_REG4, &value2) )
		return MEMS_ERROR;

	if((value & 0xF0)==0) 
		value = value | (ODR_old_value & 0xF0); //if it comes from POWERDOWN  

	switch(md) 
	{

  case LIS3DH_POWER_DOWN:
	  ODR_old_value = value;
	  value &= 0x0F;
	  break;

  case LIS3DH_NORMAL:
	  value &= 0xF7;
	  value |= (MEMS_RESET<<LIS3DH_LPEN);
	  value2 &= 0xF7;
	  value2 |= (MEMS_SET<<LIS3DH_HR);   //set HighResolution_BIT
	  break;

  case LIS3DH_LOW_POWER:		
	  value &= 0xF7;
	  value |=  (MEMS_SET<<LIS3DH_LPEN);
	  value2 &= 0xF7;
	  value2 |= (MEMS_RESET<<LIS3DH_HR); //reset HighResolution_BIT
	  break;

  default:
	  return MEMS_ERROR;
	}

	if( !LIS3DH_WriteReg(LIS3DH_CTRL_REG1, value) )
		return MEMS_ERROR;

	if( !LIS3DH_WriteReg(LIS3DH_CTRL_REG4, value2) )
		return MEMS_ERROR;  

	return MEMS_SUCCESS;

}


/** 
*
* @brief Sets the LIS3DH FullScale
*
* @param fs :  parameter to set .   \n
*
* @return MEMS_ERROR, MEMS_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
status_t WLP_Adapter::LIS3DH_SetFullScale(LIS3DH_Fullscale_t fs) 
{

	u8_t value;

	if( !LIS3DH_ReadReg(LIS3DH_CTRL_REG4, &value) )
		return MEMS_ERROR;

	value &= 0xCF;	
	value |= (fs<<LIS3DH_FS);

	if( !LIS3DH_WriteReg(LIS3DH_CTRL_REG4, value) )
		return MEMS_ERROR;

	return MEMS_SUCCESS ;
	
}




/** 
*
* @brief Enable/Disable LIS3DH Axis
*
* @param LIS3DH_X_ENABLE/DISABLE | LIS3DH_Y_ENABLE/DISABLE | LIS3DH_Z_ENABLE/DISABLE \n
*
* @return [MEMS_ERROR, MEMS_SUCCESS] \n
*
* @note You MUST use all input variable in the argument, as example \n
*
* @see   \n
*   
**/
status_t WLP_Adapter::LIS3DH_SetAxis(LIS3DH_Axis_t axis) 
{

	u8_t value;

	if( !LIS3DH_ReadReg(LIS3DH_CTRL_REG1, &value) )
		return MEMS_ERROR;
	value &= 0xF8;
	value |= (0x07 & axis);

	if( !LIS3DH_WriteReg(LIS3DH_CTRL_REG1, value) )
		return MEMS_ERROR;   

	return MEMS_SUCCESS;

}



/** 
*
* @brief  Operate the LIS3DH.
*         Read the Acceleration Values Output Registers
*
* @param  buff :  to contain the read result .  \n
*
* @return MEMS_ERROR, MEMS_SUCCESS \n
*
* @note  \n
*
* @see   \n
*   
**/
status_t WLP_Adapter::LIS3DH_GetAccAxesRaw(AxesRaw_t* buff) 
{

	i16_t value;
	u8_t *valueL = (u8_t *)(&value);
	u8_t *valueH = ((u8_t *)(&value)+1);

	if( !LIS3DH_ReadReg(LIS3DH_OUT_X_L, valueL) )
		return MEMS_ERROR;

	if( !LIS3DH_ReadReg(LIS3DH_OUT_X_H, valueH) )
		return MEMS_ERROR;

	buff->AXIS_X = value;

	if( !LIS3DH_ReadReg(LIS3DH_OUT_Y_L, valueL) )
		return MEMS_ERROR;

	if( !LIS3DH_ReadReg(LIS3DH_OUT_Y_H, valueH) )
		return MEMS_ERROR;

	buff->AXIS_Y = value;

	if( !LIS3DH_ReadReg(LIS3DH_OUT_Z_L, valueL) )
		return MEMS_ERROR;

	if( !LIS3DH_ReadReg(LIS3DH_OUT_Z_H, valueH) )
		return MEMS_ERROR;

	buff->AXIS_Z = value;

	return MEMS_SUCCESS; 

}





/** 
*
* @brief  a demo of operating the 'nano' accelerometer .
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void  WLP_Adapter::NanoAccelTest( )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return  ;
	}

	UCHAR response;
	UCHAR position=0, old_position=0;
	AxesRaw_t data;


	//Initialize MEMS Sensor
	//set ODR (turn ON device)
	response = LIS3DH_SetODR(LIS3DH_ODR_100Hz);
	if(response==1)
	{
		printf( "\n\r  SET_ODR_OK    \n\r\0");

	}
	else
	{
		printf( "\n\r  SET_ODR_FAIL    \n\r\0");
	}

	u8_t val ;
	response = LIS3DH_GetWHO_AM_I( &val ) ;
	if(response==1)
	{

		printf( "\n\r  GetWHO_AM_I_OK    \n\r\0");

	}
	else
	{
		printf( "\n\r  GetWHO_AM_I_FAIL    \n\r\0");
	}


	//set PowerMode 
	response = LIS3DH_SetMode(LIS3DH_NORMAL);
	if(response==1)
	{
		printf( "   SET_MODE_OK     \n\r\0");

	}
	else
	{
		printf( "\n\r  SET_MODE_FAIL    \n\r\0");
	}




	//set Fullscale
	response = LIS3DH_SetFullScale(LIS3DH_FULLSCALE_2);
	if(response==1)
	{
		printf( "   SET_FULLSCALE_OK\n\r\0");

	}
	else
	{
		printf( "\n\r  SET_FULLSCALE_FAIL    \n\r\0");
	}




	//set axis Enable
	response = LIS3DH_SetAxis(LIS3DH_X_ENABLE | LIS3DH_Y_ENABLE | LIS3DH_Z_ENABLE);
	if(response==1)
	{
		printf( "   SET_AXIS_OK     \n\r\0");

	}
	else
	{
		printf( "\n\r  SET_AXIS_FAIL    \n\r\0");
	}


	int times = 3*1 ;
	while( times )
	{

		//get Acceleration Raw data  
		response = LIS3DH_GetAccAxesRaw(&data);
		if(response==1)
		{
			//print data values
			//function for MKI109V1 board 
			//EKSTM32_LEDToggle(LED1);
			printf(  "X=%6d Y=%6d Z=%6d \r\n", data.AXIS_X, data.AXIS_Y, data.AXIS_Z );
		
			old_position = position;
		}

		times -- ; 

	}


}

       
            
            
#define I2C_DEV_ADDR_THERMISTER_W  0X28    //0B 0010 1000
#define I2C_DEV_ADDR_THERMISTER_R  0X29    //0B 0010 1001

#define I2C_DEV_ADDR_LTC2489_W  0X28    //0B 0010 1000
#define I2C_DEV_ADDR_LTC2489_R  0X29    //0B 0010 1001



/** 
*
* @brief set the AD sample channel 
*
* @param ChannelSet :  channel to set .  
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void WLP_Adapter::LTC2489_SetCH( UCHAR ChannelSet  )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return  ;
	}



	I2C_OPER LTC2489;
	memset( &LTC2489, 0 , sizeof(I2C_OPER ) );

	LTC2489.W_or_R     =  I2C_W ;
	LTC2489.NumOfBytes =  0 ;// data X is ignore and can cause IIC NAK,it's error for FPGA IIC control module, refer Page13, Figure 3b of LTC2489 datasheet.
	LTC2489.RegAddr    =  (ULONG)ChannelSet ;
	LTC2489.DevAddr    =  I2C_DEV_ADDR_LTC2489_W ;

	//*PULONG(LTC2489.W_Data) =  (ULONG)RegAddr ;   // no data need be written according datasheet.
	//I2CWriteData( I2CPWMOper ) ; 
	I2CCtrl( LTC2489 ) ;

}

/** 
*
* @brief LTC2489's Continuous Read 
*
* @param CH_X :  channel to set . 
*
* @return Read results \n
*
* @note  \n
*
* @see   \n
*   
**/
ULONG WLP_Adapter::LTC2489_ReadMode1(  UINT CH_X  )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return WLP_ERR ;
	}



	//	ULONG Getdata = 0 ;
	ULONG ReadData  = 0  ; 

	I2C_OPER LTC2489;
	memset( &LTC2489 , 0 , sizeof(I2C_OPER ) );

	LTC2489.W_or_R     =  I2C_R ;
	LTC2489.NumOfBytes =  0X3 ;
	LTC2489.RegAddr    =  0X0 ;
	LTC2489.DevAddr    =  I2C_DEV_ADDR_LTC2489_R ;

	*PULONG(LTC2489.R_Data)  =  0 ;

	I2CCtrl( LTC2489 ) ;
	I2CReadData( PULONG( LTC2489.R_Data ) ) ; 

	ReadData = *(PULONG)LTC2489.R_Data ;

	printf( " \n\n  Get LTC2489 data: 0X%08X at CH 0x%X  \n " , ReadData , CH_X  ) ;

	return ReadData ;


}


/** 
*
* @brief LTC2489's Continuous Read/Write.  Not realized .
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void LTC2489_ReadMode2(   )
{





}

/** 
*
* @brief LTC2489's Discarding a Conversion Result and Initiating a New Conversion with Optional Write.  
*        Not realized .
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void LTC2489_ReadMode3(   )
{





}





#define I2C_DEV_ADDR_DDR_SPD_W  0XA4    //0B 
#define I2C_DEV_ADDR_DDR_SPD_R  0XA5    //0B  

#define I2C_DEV_ADDR_DDR_SPD_W_V6  0XA6    //0B 
#define I2C_DEV_ADDR_DDR_SPD_R_V6  0XA7    //0B  


/** 
*
* @brief Caculating the DDR RAM size through read the Memory modules'SPD 
*
* @param NULL \n
*
* @return bool type \n
*
* @note  \n
*
* @see   \n
*   
**/
bool WLP_Adapter::Read_DDR_SPD(   )
{


	if ( m_bDevopened == FALSE )
	{
		printf("\n\n\n Please open the device first . \n");

		return  false ;
	}


	UCHAR SPDinfo[256];
	memset( SPDinfo , 0 , sizeof(UCHAR ) ) ;

	for ( int i = 0 ; i <18 ; i++ )
	{

		/****************************************************/
		I2C_OPER DDR_SPD ;
		memset( &DDR_SPD, 0 , sizeof(I2C_OPER ) );

		DDR_SPD.W_or_R     =  I2C_R ; 
		DDR_SPD.NumOfBytes =  1 ;
		DDR_SPD.RegAddr    =  i ;   // 

		if ( DMDtype == WLP_DMDTYPE_XGA_07A )
		{
			DDR_SPD.DevAddr    =  I2C_DEV_ADDR_DDR_SPD_R ;

			//printf( "DMDtype == WLP_DMDTYPE_XGA_07A \n"  ) ;
			//printf( "DDR_SPD.DevAddr is I2C_DEV_ADDR_DDR_SPD_R \n"  ) ;

		}
		else if (  DMDtype == WLP_DMDTYPE_1080P_095A )
		{
			DDR_SPD.DevAddr    =  I2C_DEV_ADDR_DDR_SPD_R_V6 ;

			//printf( "DMDtype == WLP_DMDTYPE_1080P_095A \n"  ) ;
			//printf( "DDR_SPD.DevAddr is I2C_DEV_ADDR_DDR_SPD_R_V6 \n"  ) ;

		}
		else
		{
			DDR_SPD.DevAddr    =  I2C_DEV_ADDR_DDR_SPD_R ;
		
			//printf( "DDR_SPD.DevAddr is I2C_DEV_ADDR_DDR_SPD_R \n"  ) ;

		}

		*PULONG(DDR_SPD.R_Data) = (ULONG)0 ;
		
		I2CCtrl( DDR_SPD ) ;

		I2CReadData	( PULONG(DDR_SPD.R_Data) ) ; 

		SPDinfo[i] = DDR_SPD.R_Data[0] ;

		//printf("  %x  \n "   , SPDinfo[i] ) ;

	}

	// Caculate the MEM size here:	
	float RAMsizeGB = 0 ;
	UINT RAMsizeMB  = 0 ;

	// DDR2 
	if ( DMDtype == WLP_DMDTYPE_XGA_07A )
	{
		int index2 = 0 ;
		index2  =  	  ( SPDinfo[3] ) + ( SPDinfo[4] ) +   // ( SPDinfo[5] & 0X03 ) can only use one rank 
				   +  (int)( log( double(SPDinfo[6] ) )/ log( (double)2) )  \
				   +  (int)( log( double(SPDinfo[17])) / log( (double)2) )  \
				   - 30 ;

		RAMsizeGB =  (float)( pow( (long)2 , (double)(index2) ) ) / (float)8 ;   //GB
	}

	// DDR3 
	if ( DMDtype == WLP_DMDTYPE_1080P_095A )
	{

		long size;
		/* calculate the total size in MB */
		size = 256 << (SPDinfo[DDR3_SPD_REG_DENSITY_BANKS] & 0xf);
		size >>= 3; /* in terms of bytes instead of bits. */
		size *= 8 << (SPDinfo[DDR3_SPD_REG_MODULE_BUS_WIDTH] & 0x7);
		size /= 4 << (SPDinfo[DDR3_SPD_REG_MODULE_ORG] & 0x7);
		size *= 1 + ((SPDinfo[DDR3_SPD_REG_MODULE_ORG] >> 3) & 0x7);

		RAMsizeGB = size / 1024 ;

	}

	/****************************************************************************/

	RAMsizeMB =  UINT( RAMsizeGB*(float)1024 ) ;

	printf( " \n\n  RAM size :  %f GB  = %d MB \n " , RAMsizeGB , RAMsizeMB ) ;
	LOG(INFO) << " \n\n  RAM size : " << RAMsizeMB << "\n\n" ;      

	RAMsize = (ULONG)( RAMsizeGB * 1024*1024*1024 ) ;  //Byte

	//RAMsize = 1024*1024*1024/2;

	if ( RAMsize == 0  )
	{

	//	printf( " \n\n  Can't find Memory Chips, define RAM size : %d GB \n " , (DDR_RAM_SIZE/1048576)/1024  ) ;
		printf( " \n\n  Can't find Memory on the board ! \n "  ) ;
		LOG(INFO) <<  " \n\n  Can't find Memory on the board ! \n "  ;

		return false ;

	}

	return true ;

}





/** 
*
* @brief Read the 68013's firmware version 
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void WLP_Adapter::Wlp_GetFWversion(  )
{

	UCHAR FWversion[30] ;
	UCHAR FWversion2[16];

	memset( FWversion , 0X00 , sizeof(UCHAR)*30 ) ;
	memset( FWversion2 , 0X00 , sizeof(UCHAR)*16 ) ;

	GetFWversion( FWversion ) ;

	for (int i= 0 ; i<15 ; i++ )
	{
		FWversion2[i] = FWversion[2*i] ;
	}

	printf( "\n\n  Firmware Version:   "  ) ;


	LOG(INFO) << "\n\n  Firmware Version:  " << FWversion2 << " \n " ;		

	for (int i= 0 ; i<15 ; i++ )
	{

		printf( "%c" , *( FWversion2 + i ) ) ;

	}

	printf( "\n"  ) ;


}




/**
*
* @brief Wlp_DevNewFrequencySet : The new method of setting frequency for the Fast clear mode
*
* @param gray :  gray depth .  
* @param frame_margin :  active time  .  
* @param frame_interval :  blank time .  
*
* @return  true or false 
*
* @note  
* Table 1 settings for DMD Active Time and DMD Blank Time for gray scale depths 1-8 for 
* maximum frame rate. The actual frame time is the sum of DMD Active Time and DMD Blank 
* Time.  The DMD Active Time is the time for which the DMD is showing an image. The DMD 
* Blank Time is the time for which the DMD is blank. The DMD Active Time and DMD Blank 
* Time can be adjusted as needed to produce any display frame rate lower than the maximum 
* frame rate. A minimum DMD blank time of 150 usec is required for gray scale bit depth of 
* 3 and greater.
* 
*      Table 1 Maximum Frame Rates
*      Gray scale  DMD                    DMD                 
*      Bit Depth  Active Time (usec)	 Blank Time(usec)    Gray BIT	  Maximum Frame Rate
*      1	       50	                 0	                 1	           20000
*      2	       150	                 0	                 2	           6667
*      3	       125	                150	                 3	           3636
*      4	       250	                150	                 4	           2500
*      5	       500	                150	                 5	           1538
*      6	       1000	                150	                 6	           870
*      7	       1900	                150	                 7	           488
*      8	       3800	                150	                 8	           253
*  
* 
* @see   \n
*
*/
bool WLP_Adapter::Wlp_DevNewFrequencySet( ULONG gray , 
										  ULONG frame_margin , 
										  ULONG frame_interval )
{


	FrameActiveTime = frame_margin ;


	int DMD_LOAD_TIME = 0 ;

	if ( DMDtype == WLP_DMDTYPE_1080P_095A )
	{

		DMD_LOAD_TIME = DMD_LOAD_TIME_1080p ;

	}
	else if (  DMDtype == WLP_DMDTYPE_XGA_07A )
	{

		DMD_LOAD_TIME = DMD_LOAD_TIME_720P ;
	
	}
	else
	{
	
		DMD_LOAD_TIME = DMD_LOAD_TIME_720P ;
	
	}




	/***************************************************************/

	float Index1 =  0 ;
 

	Index1 =  (float)pow( (LONG)2 , (double)gray ) - 1 ;


	if(  ( ( ( DMD_RESET_TIME + DMD_LOAD_TIME ) *Index1 <= frame_margin    ) 
		   &&
		    ( ( DMD_RESET_TIME + DMD_LOAD_TIME )         <= frame_interval  )
		 ) 
		 ||
		 ( ( frame_interval == 0 ) 
		   &&
		   ( ( DMD_RESET_TIME + DMD_LOAD_TIME ) *Index1 <= frame_margin )
		 )
	   )
	{

		printf( "\n\n  Set Normal Mode !  \n\n" ) ;


	}
	else if(
	( ( DMD_RESET_TIME + FAST_CLEAR_TIME )*Index1 <= frame_margin *LimitEdge2  )    // Test For LuanShuHui
	&&
	( ( DMD_RESET_TIME + DMD_LOAD_TIME   )*Index1 >= frame_margin * LimitEdge1 ) 
	&&
	( ( DMD_RESET_TIME + DMD_LOAD_TIME   )*3      <= frame_interval * LimitEdge1 )
	)
	{

		printf( "\n\n  Set Fast clear Mode !  \n\n" ) ;
	    LOG(INFO) << "\n\n  Set Fast clear Mode !  \n\n" ; 

	}
	else
	{

		//Neither

		printf( "\n\n  Neither Mode ! \n\n  Improper ActiveTime / BlankTime setting !  \n  See the 'New function of FARO'DMD.doc 'for more detail !  \n\n\n\n\n\n\n\n" ) ;
	 
		LOG(INFO) << "\n\n  Neither Mode !  \n\n" ; 
		
		return  false ;

	}

	/***************************************************************/




	ULONG ret ;

	ret = WlpDevNewFrequencySet( device  ,
								 gray  ,  
								 frame_margin   ,
								 frame_interval ) ;
	if ( ret != WLP_SUCCESS )
	{

		//return ret ;
		printf( " Set Frequency Error ! " ) ; 
	    LOG(INFO) << "\n\n  Set Frequency Error !  \n\n" ;

		return false;

	}

	return true ;

}






/** 
*
* @brief ReSet the board . For FPGA debug .
*
* @param NULL \n
*
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
void WLP_Adapter::ResetBoard(   )
{
 

	ULONG	param2 = 0;
	ULONG ret =  WlpDevControl(device, WLP_DEV_RESET, &param2) ;
	if (ret == WLP_SUCCESS)
	{
		printf("\n	 Reset device	 ----- success.\n");
		LOG(INFO) << "\n\n  Reset device ----- success. \n\n" <<endl ; 	
	}
	else
	{
		printf("\n	 Reset device	 ----- fail.\n");
		LOG(INFO) << "\n\n  Reset device ----- fail . \n\n" <<endl ; 	
		 
	}

}




/** 
*
* @brief Add on 2013.09.25.
*        Enhence the trigger function. \n
*
* @param delay     The The trigger pulse's delay time compare to the DMD begin to display
*        polarity  The trigger pulse's polarity
*        plusewidth The trigger pulse's width 
*        ImageNum  Downloaded images' number
*         
* @return NULL \n
*
* @note  \n
*
* @see   \n
*   
**/
 bool WLP_Adapter::TriggerExtSet(  ULONG delay , 
	                               bool polarity , 
								   ULONG plusewidth , 
								   ULONG ImageNum )
 {


	 if ( (plusewidth + delay) >= FrameActiveTime )
	 {
		 printf("\n	 Improper trigger setting !	 \n   Plusewidth add delay time must NOT LESS than the ActiveTime ! \n");
		 LOG(INFO) << "\n\n   Improper trigger setting !  \n   Plusewidth add delay time must NOT LESS than the ActiveTime !	 \n\n" << endl;

		 return false;

	 }



	 delay = delay + 7 ;

	 if ( delay == 0 )
	 {
		 delay = 12 ;
	 }
	 else
	 {
		 delay = delay*48 ;
	 }

	ULONG ret = 0 ;
	ret = WlpDevTriggerExtSet( device ,  
		                       delay  ,  
							   polarity ,  
							   plusewidth *48 , 
							   ImageNum ) ;
	if (ret == WLP_SUCCESS)
	{

		printf("\n	 Set Trigger Extension	 ----- success.\n");
		LOG(INFO) << "\n\n  Set Trigger Extension ----- success. \n\n" <<endl ; 

		return true ;
	}
	else
	{

		printf("\n	 Set Trigger Extension	 ----- fail.\n");
		LOG(INFO) << "\n\n  Set Trigger Extension ----- fail . \n\n" <<endl ; 	

		return false ;
	}


 }




